
var {Services} = ChromeUtils.import("resource://gre/modules/Services.jsm");
var {CustomizableUI} = ChromeUtils.import("resource:///modules/CustomizableUI.jsm");
var PREF_BRANCH = "extensions.add_toolbar_buttons.", ServPrefs, contExt, baseUri, ns_xul = "http://www.mozilla.org/keymaster/gatekeeper/there.is.only.xul";
try {
    ChromeUtils.defineModuleGetter(this, "PlacesUtils", "resource://gre/modules/PlacesUtils.jsm");
    XPCOMUtils.defineLazyGlobalGetters(this, ["XMLHttpRequest"]);
} catch(e) {}
var add_toolbar_buttons = {
    initialized: false,
    favrunning: false,
    bookmarksInsertRemove: false,
    get ClipboardHelper() {
        delete this.ClipboardHelper;
        return this.ClipboardHelper = Cc["@mozilla.org/widget/clipboardhelper;1"].getService(Ci.nsIClipboardHelper);
    },
    get AlertsService() {
        delete this.AlertsService;
        return this.AlertsService = Cc["@mozilla.org/alerts-service;1"].getService(Ci.nsIAlertsService);
    },
    get styleSS() {
        delete this.styleSS;
        return this.styleSS = Cc["@mozilla.org/content/style-sheet-service;1"].getService(Ci.nsIStyleSheetService);
    },
    get SessionStore() {
        delete this.SessionStore;
        return this.SessionStore = Cc["@mozilla.org/browser/sessionstore;1"].getService(Ci.nsISessionStore);
    },
    get styleURI() {
        delete this.styleURI;
        return this.styleURI = Services.io.newURI(`${baseUri}button.css`);
    },
    get ExtensionPrefBranch() {
        delete this.ExtensionPrefBranch;
        return this.ExtensionPrefBranch = ServPrefs.getBranch(PREF_BRANCH);
    },
    get permissions_default_image() {
        delete this.permissions_default_image;
        try {
            return this.permissions_default_image = ServPrefs.getIntPref("permissions.default.image");
        } catch(e) { }
        return this.permissions_default_image = null;
    },
    get javascript_enabled() {
        delete this.javascript_enabled;
        try {
            return this.javascript_enabled = ServPrefs.getBoolPref("javascript.enabled");
        } catch(e) { }
        return this.javascript_enabled = null;
    },
    get media_autoplay_enabled() {
        delete this.media_autoplay_enabled;
        try {
            return this.media_autoplay_enabled = ServPrefs.getBoolPref("media.autoplay.enabled");
        } catch(e) { }
        return this.media_autoplay_enabled = null;
    },
    get media_autoplay_default() {
        delete this.media_autoplay_default;
        try {
            return this.media_autoplay_default = ServPrefs.getIntPref("media.autoplay.default");
        } catch(e) { }
        return this.media_autoplay_default = null;
    },
    get browser_zoom_full() {
        delete this.browser_zoom_full;
        try {
            return this.browser_zoom_full = ServPrefs.getBoolPref("browser.zoom.full");
        } catch(e) { }
        return this.browser_zoom_full = null;
    },
    get network_cookie_cookieBehavior() {
        delete this.network_cookie_cookieBehavior;
        try {
            return this.network_cookie_cookieBehavior = ServPrefs.getIntPref("network.cookie.cookieBehavior");
        } catch(e) { }
        return this.network_cookie_cookieBehavior = null;
    },
    get network_proxy_type() {
        delete this.network_proxy_type;
        try {
            return this.network_proxy_type = ServPrefs.getIntPref("network.proxy.type");
        } catch(e) { }
        return this.network_proxy_type = null;
    },
    get image_animation_mode() {
        delete this.image_animation_mode;
        try {
            return this.image_animation_mode = ServPrefs.getCharPref("image.animation_mode");
        } catch(e) { }
        return this.image_animation_mode = null;
    },
    get anim_func() {
        delete this.anim_func;
        try {
            return this.anim_func = this.ExtensionPrefBranch.getBoolPref("obs.animfunc");
        } catch(e) { }
        return this.anim_func = null;
    },
    get animationCSS() {
        return `@namespace url("http://www.w3.org/1999/xhtml"); @namespace svg url("http://www.w3.org/2000/svg"); @-moz-document url-prefix("http:"), url-prefix("https:"), url-prefix("about:blank"), url-prefix("ftp:"), url-prefix("file:") { *, *::before, *::after, svg|* { ${!this.anim_func ? "transition: none !important; animation: none !important;" : "transition-timing-function: step-start !important; animation-timing-function: step-start !important;"} } }`;
    },
    get anim_css() {
        delete this.anim_css;
        try {
            var _anim_css = this.ExtensionPrefBranch.getBoolPref("obs.animation");
            this.cssFileToUserContent(this.animationCSS, _anim_css);
            return this.anim_css = _anim_css;
        } catch(e) { }
        return this.anim_css = null;
    },
    get framescript() {
        delete this.framescript;
        return this.framescript = encodeURIComponent(`(${(function() {
            var adds_pages = {
                gFrameList: [],
                running: false,
                init: function() {
                    addMessageListener("requestAddsFrameScript", this);
                },
                receiveMessage: function(msg) {
                    switch (msg.data.func) {
                        case "scrollPageUp":
                        content.scrollByPages(-1);
                        break;
                        case "scrollPageDown":
                        content.scrollByPages(1);
                        break;
                        case "scrollTop":
                        content.scrollTo(0, 0);
                        break;
                        case "scrollBottom":
                        content.scrollTo(0, content.scrollMaxY);
                        break;
                        case "PageJavascript":
                        if (docShell.allowJavascript) {
                            docShell.allowJavascript = false;
                            sendAsyncMessage("responseAddsFrameScript", {func: "DisableJavascript"});
                        } else {
                            docShell.allowJavascript = true;
                            sendAsyncMessage("responseAddsFrameScript", {func: "EnableJavascript"});
                        }
                        break;
                        case "PageImages":
                        if (docShell.allowImages) {
                            docShell.allowImages = false;
                            sendAsyncMessage("responseAddsFrameScript", {func: "DisableImages"});
                        } else {
                            docShell.allowImages = true;
                            sendAsyncMessage("responseAddsFrameScript", {func: "EnableImages"});
                        }
                        break;
                        case "TextToLink":
                        this.texttolink();
                        break;
                        case "CopyAllLinks":
                        this.copyalllinks();
                        break;
                        case "LinkPointerEvents":
                        this.linkpointerevents();
                        break;
                    }
                },
                texttolink: function() {
                    if (this.running || !content.document || !content.document.body)
                        return;
                    this.running = true;
                    this.gFrameList = [];
                    this.goThroughFrames(content.document, content.window);
                    var excludedTags, linkPack, linkify, setLink, url_regexp, xPath, clearLink;
                    url_regexp = /((https?\:\/\/|ftps?\:\/\/|www\.)[!-~а-я]+[\wа-я\/=]|([\wа-я][\wа-я._-]+\.(com|ru|org|net|io|info|tv|cc|gov|xxx|uk|cn|edu|бг|бел|ею|қаз|мкд|мон|рус|рф|срб|укр))(\/[!-~а-я]*[\w\/])?)/ig;
                    setLink = function(candidate, doc) {
                        var span, text;
                        if (candidate == null || candidate.parentNode.className == "add__TextToLink" || candidate.nodeName == "#cdata-section")
                            return;
                        text = candidate.textContent.replace(url_regexp, '<a href="$1" target="_blank" class="add__TextToLink">$1</a>');
                        if (candidate.textContent.length == text.length)
                            return;
                        span = doc.createElement("span");
                        span.innerHTML = text;
                        candidate.parentNode.replaceChild(span, candidate);
                    };
                    excludedTags = "a,svg,canvas,applet,input,button,area,embed,frame,frameset,head,iframe,img,option,map,meta,noscript,object,script,style,textarea,code".split(",");
                    xPath = '//text()[not(ancestor::' + excludedTags.join(') and not(ancestor::') + ')]';
                    linkPack = function(result, start, doc) {
                        var i, j, k, ref, ref1, ref2, ref3, startTime;
                        startTime = Date.now();
                        while (start + 10000 < result.snapshotLength) {
                            for (i = j = ref = start, ref1 = start + 10000; ref <= ref1 ? j <= ref1 : j >= ref1; i = ref <= ref1 ? ++j : --j)
                                setLink(result.snapshotItem(i), doc);
                            start += 10000;
                            if (Date.now() - startTime > 2500)
                                return;
                        }
                        for (i = k = ref2 = start, ref3 = result.snapshotLength; ref2 <= ref3 ? k <= ref3 : k >= ref3; i = ref2 <= ref3 ? ++k : --k)
                            setLink(result.snapshotItem(i), doc);
                    };
                    clearLink = function(doc) {
                        for (let elem of doc.querySelectorAll("a.add__TextToLink[href]:not([href^='http']):not([href^='ftp'])")) {
                            elem.setAttribute("href", "http://" + elem.getAttribute("href"));
                        }
                    };
                    linkify = function(doc) {
                        var result = doc.evaluate(xPath, doc.body, null, doc.ownerGlobal.XPathResult.UNORDERED_NODE_SNAPSHOT_TYPE, null);
                        linkPack(result, 0, doc);
                    };
                    this.gFrameList.forEach(doc => {
                        if (doc.body) {
                            linkify(doc);
                            clearLink(doc);
                        }
                    });
                    this.gFrameList = [];
                    this.running = false;
                },
                goThroughFrames: function(aDocument, aWindow) {
                    if (!aDocument) return;
                    this.gFrameList.push(aDocument);
                    var num = aWindow.frames.length;
                    if (num > 0) {
                        for (let i = 0; i < num; i++) {
                            let frame = aWindow.frames[i], doc;
                            try {
                                doc = frame.document;
                            } catch (e) {}
                            this.goThroughFrames(doc, frame);
                        }
                    }
                },
                copyalllinks: function() {
                    if (this.running || !content.document || !content.document.body)
                        return;
                    this.running = true;
                    this.gFrameList = [];
                    this.goThroughFrames(content.document, content.window);
                    var list = "", acount = 0;
                    this.gFrameList.forEach(doc => {
                        var a = doc.querySelectorAll(":any-link:not([href='#']):not([href^='javascript'])");
                        for (let f of a) {
                            let uri = f.href;
                            try {
                                uri = Services.io.newURI(uri).displaySpec;
                            } catch (e) {}
                            try {
                                uri = decodeURIComponent(uri);
                            } catch (e) {}
                            list += uri + "\n";
                            acount += 1;
                        }
                    });
                    sendAsyncMessage("responseAddsFrameScript", {func: "AllLinksCopy", links: list, count: "" + acount});
                    this.gFrameList = [];
                    this.running = false;
                },
                linkpointerevents: function() {
                    if (this.running || !content.document || !content.document.body)
                        return;
                    this.running = true;
                    this.gFrameList = [];
                    this.goThroughFrames(content.document, content.window);
                    this.gFrameList.forEach(doc => {
                        var del = doc.querySelector("style#__add_toolbar_buttons_link_none");
                        if (del)
                            del.remove();
                        else {
                            let head = doc.querySelector("head"), style = doc.createElement("style");
                            style.setAttribute("type", "text/css");
                            style.setAttribute("id", "__add_toolbar_buttons_link_none");
                            style.innerHTML = ":root :any-link:not([href='#']) {pointer-events: none !important; text-decoration: none !important;} :root * {-moz-user-select: text !important;}";
                            if (head)
                                head.append(style);
                            else
                                doc.documentElement.append(style);
                        }
                    });
                    this.gFrameList = [];
                    this.running = false;
                },
                ininit: function() {
                    removeMessageListener("requestAddsFrameScript", this);
                    sendAsyncMessage("responseAddsFrameScript", {func: "unloadFrameScript"});
                }
            };
            adds_pages.init();
            addEventListener("unload", function unload() {
                adds_pages.ininit();
            }, { once: true });
        })})();`);
    },
    init() {
        if (this.initialized)
            return;
        this.initialized = true;
        ServPrefs = Services.prefs;
        var branch = ServPrefs.getDefaultBranch(PREF_BRANCH);
        branch.setBoolPref("newtab", false);
        branch.setBoolPref("obs.animation", true);
        branch.setBoolPref("obs.animfunc", false);
        branch.setBoolPref("doreload", false);
        branch.setIntPref("toggleproxy", 5);
        branch.setIntPref("toggleproxy2", 0);
        branch.setIntPref("maxrequests", 50);
        branch.setIntPref("maxtimeout", 30);
        branch.setBoolPref("alertnotification", true);
        branch.setIntPref("bookmarksparentguid", 0);
        branch.setBoolPref("bookmarksindex", false);
        for (let win of contExt.windowManager.getAll())
            this.loadButtonStyle(win.window);
        var showInPrivate = contExt.privateBrowsingAllowed || false;
        try {
            CustomizableUI.createWidget({
                id: "b-image-toggle",
                type: "custom",
                label: "Переключить изображения",
                tooltiptext: "ЛКМ: Переключить загрузку изображений\nShift+ЛКМ: Переключить загрузку изображений на текущей странице\nСКМ: Переключить загрузку изображений на текущей странице",
                localized: false,
                showInPrivateBrowsing: showInPrivate,
                onBuild: function(document) {
                    var win = document.defaultView, toolbarbutton_0 = document.createElementNS(ns_xul, "toolbarbutton");
                    toolbarbutton_0.id = "b-image-toggle";
                    toolbarbutton_0.setAttribute("label", "Переключить изображения");
                    toolbarbutton_0.setAttribute("tooltiptext", "ЛКМ: Переключить загрузку изображений\nShift+ЛКМ: Переключить загрузку изображений на текущей странице\nСКМ: Переключить загрузку изображений на текущей странице");
                    var image = add_toolbar_buttons.permissions_default_image;
                    if (image !== null) {
                        toolbarbutton_0.setAttribute("activated", image);
                        toolbarbutton_0.addEventListener("click", function(event) {
                            if (event.button == 0) {
                                if (!event.shiftKey) {
                                    add_toolbar_buttons.prefToggleNumber("permissions.default.image", [1,2,3,1]);
                                    add_toolbar_buttons.checkBrowserReload(win);
                                } else
                                    add_toolbar_buttons.sendAsyncMessages(win, "PageImages");
                            } else if (event.button == 1)
                                add_toolbar_buttons.sendAsyncMessages(win, "PageImages");
                        });
                    }
                    toolbarbutton_0.classList.add("toolbarbutton-1", "chromeclass-toolbar-additional");
                    return toolbarbutton_0;
                }
            });
        } catch(e) {}
        try {
            CustomizableUI.createWidget({
                id: "b-stop-animation",
                type: "custom",
                label: "Переключить анимацию",
                tooltiptext: "ЛКМ: Остановить или Запустить CSS, SVG анимацию\nСКМ: Переключить анимацию - normal / none\nПКМ: Переключить анимацию - normal / none / once",
                localized: false,
                showInPrivateBrowsing: showInPrivate,
                onBuild: function(document) {
                    var win = document.defaultView, toolbarbutton_0 = document.createElementNS(ns_xul, "toolbarbutton");
                    toolbarbutton_0.id = "b-stop-animation";
                    toolbarbutton_0.setAttribute("badged", "true");
                    toolbarbutton_0.setAttribute("constrain-size", "true");
                    toolbarbutton_0.setAttribute("label", "Переключить анимацию");
                    toolbarbutton_0.setAttribute("context", "false");
                    toolbarbutton_0.setAttribute("tooltiptext", "ЛКМ: Остановить или Запустить CSS, SVG анимацию\nСКМ: Переключить анимацию - normal / none\nПКМ: Переключить анимацию - normal / none / once");
                    var anim_css = add_toolbar_buttons.anim_css, image_animation_mode = add_toolbar_buttons.image_animation_mode;
                    if (anim_css !== null && image_animation_mode !== null) {
                        toolbarbutton_0.setAttribute("activated", anim_css);
                        toolbarbutton_0.setAttribute("badge", image_animation_mode.substring(0, 3));
                        toolbarbutton_0.setAttribute("badgeStyle", "background: rgba(0, 120, 173, .6); color: rgb(255, 255, 255); font-size: 10px; box-shadow: none; text-shadow: none; padding: 0px 1px 2px 1px !important;");
                        toolbarbutton_0.addEventListener("click", function(event) {
                            if (event.button == 0)
                                add_toolbar_buttons.extensionPrefToggleStatus("obs.animation");
                            else if (event.button == 1) {
                                add_toolbar_buttons.prefToggleString("image.animation_mode", ["normal", "none"]);
                                add_toolbar_buttons.checkBrowserReload(win);
                            } else if (event.button == 2) {
                                event.preventDefault();
                                event.stopPropagation();
                                add_toolbar_buttons.prefToggleString("image.animation_mode", ["normal", "none", "once"]);
                                add_toolbar_buttons.checkBrowserReload(win);
                            }
                        });
                    }
                    toolbarbutton_0.classList.add("toolbarbutton-1", "chromeclass-toolbar-additional", "badged-button");
                    return toolbarbutton_0;
                }
            });
        } catch(e) {}
        try {
            CustomizableUI.createWidget({
                id: "b-autoplay",
                type: "custom",
                label: "Переключить видео/аудио",
                tooltiptext: "Переключить авто-воспроизведение HTML5 видео/аудио",
                localized: false,
                showInPrivateBrowsing: showInPrivate,
                onBuild: function(document) {
                    var win = document.defaultView, autoplay = add_toolbar_buttons.media_autoplay_enabled, autoplay_default = false;
                    if (autoplay === null) {
                        autoplay = add_toolbar_buttons.media_autoplay_default;
                        autoplay_default = true;
                    }
                    var toolbarbutton_0 = document.createElementNS(ns_xul, "toolbarbutton");
                    toolbarbutton_0.id = "b-autoplay";
                    toolbarbutton_0.setAttribute("label", "Переключить видео/аудио");
                    toolbarbutton_0.setAttribute("tooltiptext", "Переключить авто-воспроизведение HTML5 видео/аудио");
                    if (autoplay !== null) {
                        toolbarbutton_0.setAttribute("activated", autoplay);
                        if (autoplay_default)
                            toolbarbutton_0.addEventListener("command", function(event) {
                                add_toolbar_buttons.prefToggleNumber("media.autoplay.default", [1,5,0]);
                                add_toolbar_buttons.checkBrowserReload(win);
                            });
                        else
                            toolbarbutton_0.addEventListener("command", function(event) {
                                add_toolbar_buttons.prefToggleStatus("media.autoplay.enabled");
                                add_toolbar_buttons.checkBrowserReload(win);
                            });
                    }
                    toolbarbutton_0.classList.add("toolbarbutton-1", "chromeclass-toolbar-additional");
                    return toolbarbutton_0;
                }
            });
        } catch(e) {}
        try {
            CustomizableUI.createWidget({
                id: "b-javascript",
                type: "custom",
                label: "Переключить JavaScript",
                tooltiptext: "ЛКМ: Переключить JavaScript\nShift+ЛКМ: Переключить JavaScript на текущей странице\nСКМ: Переключить JavaScript на текущей странице",
                localized: false,
                showInPrivateBrowsing: showInPrivate,
                onBuild: function(document) {
                    var win = document.defaultView, toolbarbutton_0 = document.createElementNS(ns_xul, "toolbarbutton");
                    toolbarbutton_0.id = "b-javascript";
                    toolbarbutton_0.setAttribute("label", "Переключить JavaScript");
                    toolbarbutton_0.setAttribute("tooltiptext", "ЛКМ: Переключить JavaScript\nShift+ЛКМ: Переключить JavaScript на текущей странице\nСКМ: Переключить JavaScript на текущей странице");
                    var javascript = add_toolbar_buttons.javascript_enabled;
                    if (javascript !== null) {
                        toolbarbutton_0.setAttribute("activated", javascript);
                        toolbarbutton_0.addEventListener("click", function(event) {
                            if (event.button == 0) {
                                if (!event.shiftKey) {
                                    add_toolbar_buttons.prefToggleStatus("javascript.enabled");
                                    add_toolbar_buttons.checkBrowserReload(win);
                                } else
                                    add_toolbar_buttons.sendAsyncMessages(win, "PageJavascript");
                            } else if (event.button == 1)
                                add_toolbar_buttons.sendAsyncMessages(win, "PageJavascript");
                        });
                    }
                    toolbarbutton_0.classList.add("toolbarbutton-1", "chromeclass-toolbar-additional");
                    return toolbarbutton_0;
                }
            });
        } catch(e) {}
        try {
            CustomizableUI.createWidget({
                id: "b-cookie-toggle",
                type: "custom",
                label: "Переключить Куки",
                tooltiptext: "ЛКМ: Переключить Куки\nСКМ: Удалить куки домена текущей страницы\nПКМ: Управление куками",
                localized: false,
                showInPrivateBrowsing: showInPrivate,
                onBuild: function(document) {
                    var win = document.defaultView, toolbarbutton_0 = document.createElementNS(ns_xul, "toolbarbutton");
                    toolbarbutton_0.id = "b-cookie-toggle";
                    toolbarbutton_0.setAttribute("label", "Переключить Куки");
                    toolbarbutton_0.setAttribute("context", "false");
                    toolbarbutton_0.setAttribute("tooltiptext", "ЛКМ: Переключить Куки\nСКМ: Удалить куки домена текущей страницы\nПКМ: Управление куками");
                    var cookieBehavior = add_toolbar_buttons.network_cookie_cookieBehavior;
                    if (cookieBehavior !== null) {
                        toolbarbutton_0.setAttribute("activated", cookieBehavior);
                        toolbarbutton_0.addEventListener("click", function(event) {
                            if (event.button == 0)
                                add_toolbar_buttons.prefToggleNumber("network.cookie.cookieBehavior", [1,2,3,0]);
                            else if (event.button == 1) {
                                (this._clearSiteData || ("gIdentityHandler" in win && "clearSiteData" in win.gIdentityHandler && (this._clearSiteData = win.eval(`(${`${win.gIdentityHandler.clearSiteData}`.replace(/^.*clearSiteData/, "async function clearSiteData").replace(/this\s*\./g, "gIdentityHandler.").replace(/PanelMultiView\.hidePopup.+;|event\.stopPropagation.+;/g, "")})`))) || (this._clearSiteData = function() {}))(event);
                            } else if (event.button == 2) {
                                event.preventDefault();
                                event.stopPropagation();
                                add_toolbar_buttons.viewCookies(win);
                            }
                        });
                    }
                    toolbarbutton_0.classList.add("toolbarbutton-1", "chromeclass-toolbar-additional");
                    return toolbarbutton_0;
                }
            });
        } catch(e) {}
        try {
            CustomizableUI.createWidget({
                id: "b-zoom-toggle",
                type: "custom",
                label: "Только текст",
                tooltiptext: "Переключение масштабирования текста и страницы",
                localized: false,
                showInPrivateBrowsing: showInPrivate,
                onBuild: function(document) {
                    var win = document.defaultView, toolbarbutton_0 = document.createElementNS(ns_xul, "toolbarbutton");
                    toolbarbutton_0.id = "b-zoom-toggle";
                    toolbarbutton_0.setAttribute("label", "Только текст");
                    toolbarbutton_0.setAttribute("tooltiptext", "Переключение масштабирования текста и страницы");
                    var zoom = add_toolbar_buttons.browser_zoom_full;
                    if (zoom !== null) {
                        toolbarbutton_0.setAttribute("activated", zoom);
                        toolbarbutton_0.addEventListener("command", function(event) {
                            win.ZoomManager.toggleZoom();
                        });
                    }
                    toolbarbutton_0.classList.add("toolbarbutton-1", "chromeclass-toolbar-additional");
                    return toolbarbutton_0;
                }
            });
        } catch(e) {}
        try {
            CustomizableUI.createWidget({
                id: "toolbaritem-b-toggle-proxy",
                type: "custom",
                label: "Переключить прокси",
                tooltiptext: "Переключить прокси",
                localized: false,
                showInPrivateBrowsing: showInPrivate,
                onBuild: function(document) {
                    var win = document.defaultView, toolbaritem = document.createElementNS(ns_xul, "toolbaritem");
                    toolbaritem.id = "toolbaritem-b-toggle-proxy";
                    toolbaritem.className = "chromeclass-toolbar-additional";
                    toolbaritem.setAttribute("label", "Переключить прокси");
                    toolbaritem.setAttribute("type", "custom");
                    var toolbarbutton_0 = document.createElementNS(ns_xul, "toolbarbutton");
                    toolbarbutton_0.id = "b-toggle-proxy";
                    toolbarbutton_0.setAttribute("label", "Переключить прокси");
                    toolbarbutton_0.setAttribute("tooltiptext", "Переключить прокси");
                    toolbarbutton_0.setAttribute("context", "false");
                    toolbarbutton_0.classList.add("toolbarbutton-1");
                    toolbaritem.append(toolbarbutton_0);
                    var toolbarbutton_1 = document.createElementNS(ns_xul, "toolbarbutton");
                    toolbarbutton_1.id = "b-toggle-proxy-menu";
                    toolbarbutton_1.setAttribute("type", "menu");
                    toolbarbutton_1.setAttribute("label", "");
                    toolbarbutton_1.setAttribute("tooltiptext", "ЛКМ: Открыть меню\nПКМ: Открыть настройки прокси");
                    toolbarbutton_1.setAttribute("context", "false");
                    toolbarbutton_1.classList.add("toolbarbutton-1");
                    toolbarbutton_1.addEventListener("click", function(event) {
                        if (event.button == 2) {
                            event.preventDefault();
                            event.stopPropagation();
                            add_toolbar_buttons.openProxyWin(win);
                        }
                    });
                    var menupopup_0 = document.createElementNS(ns_xul, "menupopup");
                    menupopup_0.id = "b-toggle-proxy-popup";
                    menupopup_0.addEventListener("click", function(event) {
                        event.stopPropagation();
                    });
                    var proxy = add_toolbar_buttons.network_proxy_type;
                    if (proxy !== null) {
                        toolbaritem.setAttribute("activated", add_toolbar_buttons.network_proxy_type);
                        toolbarbutton_0.addEventListener("command", function(event) {
                            add_toolbar_buttons.toggleTheProxy();
                            add_toolbar_buttons.checkBrowserReload(win);
                        });
                        menupopup_0.addEventListener("command", function(event) {
                            event.stopPropagation();
                            add_toolbar_buttons.setProxyValue(event);
                            add_toolbar_buttons.checkBrowserReload(win);
                        });
                        menupopup_0.addEventListener("popupshowing", function(event) {
                            add_toolbar_buttons.setProxyMenuItem(event, event.currentTarget);
                        });
                    }
                    var menuitem_0 = document.createElementNS(ns_xul, "menuitem");
                    menuitem_0.setAttribute("label", "Прямое подключение, без прокси");
                    menuitem_0.setAttribute("type", "radio");
                    menuitem_0.setAttribute("value", "0");
                    menupopup_0.append(menuitem_0);
                    var menuitem_1 = document.createElementNS(ns_xul, "menuitem");
                    menuitem_1.setAttribute("label", "Ручная настройка прокси");
                    menuitem_1.setAttribute("type", "radio");
                    menuitem_1.setAttribute("value", "1");
                    menupopup_0.append(menuitem_1);
                    var menuitem_2 = document.createElementNS(ns_xul, "menuitem");
                    menuitem_2.setAttribute("label", "Автоматическая настройка прокси");
                    menuitem_2.setAttribute("type", "radio");
                    menuitem_2.setAttribute("value", "2");
                    menupopup_0.append(menuitem_2);
                    var menuitem_3 = document.createElementNS(ns_xul, "menuitem");
                    menuitem_3.setAttribute("label", "Автоопределение настроек прокси");
                    menuitem_3.setAttribute("type", "radio");
                    menuitem_3.setAttribute("value", "4");
                    menupopup_0.append(menuitem_3);
                    var menuitem_4 = document.createElementNS(ns_xul, "menuitem");
                    menuitem_4.setAttribute("label", "Использовать системные настройки прокси");
                    menuitem_4.setAttribute("type", "radio");
                    menuitem_4.setAttribute("value", "5");
                    menupopup_0.append(menuitem_4);
                    var menuseparator_0 = document.createElementNS(ns_xul, "menuseparator");
                    menupopup_0.append(menuseparator_0);
                    var menuitem_5 = document.createElementNS(ns_xul, "menuitem");
                    menuitem_5.setAttribute("label", "Открыть настройки прокси");
                    menuitem_5.addEventListener("command", function(event) {
                        event.stopPropagation();
                        add_toolbar_buttons.openProxyWin(win);
                    });
                    menupopup_0.append(menuitem_5);
                    toolbarbutton_1.append(menupopup_0);
                    toolbaritem.append(toolbarbutton_1);
                    return toolbaritem;
                }
            });
        } catch(e) {}
        try {
            CustomizableUI.createWidget({
                id: "toolbaritem-b-undo-tab",
                type: "custom",
                label: "Восстановить",
                tooltiptext: "ЛКМ: Восстановить вкладку\nПКМ: Восстановить окно",
                localized: false,
                showInPrivateBrowsing: showInPrivate,
                onBuild: function(document) {
                    var win = document.defaultView, toolbaritem = document.createElementNS(ns_xul, "toolbaritem");
                    toolbaritem.id = "toolbaritem-b-undo-tab";
                    toolbaritem.className = "chromeclass-toolbar-additional";
                    toolbaritem.setAttribute("label", "Восстановить");
                    toolbaritem.setAttribute("type", "custom");
                    var toolbarbutton_0 = document.createElementNS(ns_xul, "toolbarbutton");
                    toolbarbutton_0.id = "b-undo-tab";
                    toolbarbutton_0.setAttribute("label", "Восстановить");
                    toolbarbutton_0.setAttribute("tooltiptext", "ЛКМ: Восстановить вкладку\nПКМ: Восстановить окно");
                    toolbarbutton_0.setAttribute("context", "false");
                    toolbarbutton_0.classList.add("toolbarbutton-1");
                    toolbarbutton_0.addEventListener("click", function(event) {
                        if (event.button == 0)
                            win.undoCloseTab();
                        else if (event.button == 2) {
                            event.preventDefault();
                            event.stopPropagation();
                            win.undoCloseWindow();
                        }
                    });
                    toolbaritem.append(toolbarbutton_0);
                    var toolbarbutton_1 = document.createElementNS(ns_xul, "toolbarbutton");
                    toolbarbutton_1.id = "b-undo-tab-menu";
                    toolbarbutton_1.setAttribute("type", "menu");
                    toolbarbutton_1.setAttribute("label", "");
                    toolbarbutton_1.setAttribute("tooltiptext", "ЛКМ: Открыть меню\nПКМ: Показать весь журнал");
                    toolbarbutton_1.setAttribute("context", "false");
                    toolbarbutton_1.classList.add("toolbarbutton-1");
                    toolbarbutton_1.addEventListener("click", function(event) {
                        if (event.button == 2) {
                            event.preventDefault();
                            event.stopPropagation();
                            win.PlacesCommandHook.showPlacesOrganizer("History");
                        }
                    });
                    var menupopup_0 = document.createElementNS(ns_xul, "menupopup");
                    menupopup_0.id = "b-undo-tab-popup";
                    menupopup_0.setAttribute("tooltip", "bhTooltip");
                    menupopup_0.setAttribute("popupsinherittooltip", true);
                    menupopup_0.addEventListener("click", function(event) {
                        event.stopPropagation();
                    });
                    menupopup_0.addEventListener("command", function(event) {
                        event.stopPropagation();
                    });
                    var menu_0 = document.createElementNS(ns_xul, "menu");
                    menu_0.setAttribute("disabled", true);
                    menu_0.setAttribute("label", "Недавно закрытые вкладки");
                    var menupopup_1 = document.createElementNS(ns_xul, "menupopup");
                    menupopup_1.addEventListener("popupshowing", function(event) {
                        var SessionStore = win.SessionStore || add_toolbar_buttons.SessionStore;
                        while (menupopup_1.hasChildNodes())
                            menupopup_1.firstChild.remove();
                        if (win == Services.appShell.hiddenDOMWindow || SessionStore.getClosedTabCount(win) == 0) {
                            menu_0.setAttribute("disabled", true);
                            return;
                        }
                        if ("RecentlyClosedTabsAndWindowsMenuUtils" in win) {
                            var tabsFragment = win.RecentlyClosedTabsAndWindowsMenuUtils.getTabsFragment(win, "menuitem");
                            menupopup_1.append(tabsFragment);
                            menu_0.removeAttribute("disabled");
                        }
                    });
                    menu_0.append(menupopup_1);
                    menupopup_0.append(menu_0);
                    var menu_1 = document.createElementNS(ns_xul, "menu");
                    menu_1.setAttribute("disabled", true);
                    menu_1.setAttribute("label", "Недавно закрытые окна");
                    var menupopup_2 = document.createElementNS(ns_xul, "menupopup");
                    menupopup_2.addEventListener("popupshowing", function(event) {
                        var SessionStore = win.SessionStore || add_toolbar_buttons.SessionStore;
                        while (menupopup_2.hasChildNodes())
                            menupopup_2.firstChild.remove();
                        if (SessionStore.getClosedWindowCount() == 0) {
                            menu_1.setAttribute("disabled", true);
                            return;
                        }
                        if ("RecentlyClosedTabsAndWindowsMenuUtils" in win) {
                            var windowsFragment = win.RecentlyClosedTabsAndWindowsMenuUtils.getWindowsFragment(win, "menuitem");
                            menupopup_2.append(windowsFragment);
                            menu_1.removeAttribute("disabled");
                        }
                    });
                    menu_1.append(menupopup_2);
                    menupopup_0.append(menu_1);
                    menupopup_0.addEventListener("popupshowing", function(event) {
                        var SessionStore = win.SessionStore || add_toolbar_buttons.SessionStore;
                        if (win == Services.appShell.hiddenDOMWindow || SessionStore.getClosedTabCount(win) == 0)
                            menu_0.setAttribute("disabled", true);
                        else
                            menu_0.removeAttribute("disabled");
                        if (SessionStore.getClosedWindowCount() == 0)
                            menu_1.setAttribute("disabled", true);
                        else
                            menu_1.removeAttribute("disabled");
                    });
                    var menuitem_0 = document.createElementNS(ns_xul, "menuitem");
                    menuitem_0.id = "b-undo-all-history";
                    menuitem_0.setAttribute("label", "Показать весь журнал");
                    menuitem_0.addEventListener("command", function(event) {
                        event.stopPropagation();
                        win.PlacesCommandHook.showPlacesOrganizer("History");
                    });
                    menupopup_0.append(menuitem_0);
                    var menuitem_1 = document.createElementNS(ns_xul, "menuitem");
                    menuitem_1.setAttribute("label", "Удалить недавнюю историю…");
                    menuitem_1.addEventListener("command", function(event) {
                        event.stopPropagation();
                        add_toolbar_buttons.openSanitizeWin(win);
                    });
                    menupopup_0.append(menuitem_1);
                    toolbarbutton_1.append(menupopup_0);
                    toolbaritem.append(toolbarbutton_1);
                    return toolbaritem;
                }
            });
        } catch(e) {}
        try {
            CustomizableUI.createWidget({
                id: "b-newtab",
                type: "custom",
                label: "Новая вкладка",
                tooltiptext: "ЛКМ: Открыть новую вкладку\nСКМ: Открыть новую вкладку рядом с текущей\nПКМ: Переместить текущюю вкладку в новое окно",
                localized: false,
                showInPrivateBrowsing: showInPrivate,
                onBuild: function(document) {
                    var win = document.defaultView, toolbarbutton_0 = document.createElementNS(ns_xul, "toolbarbutton");
                    toolbarbutton_0.id = "b-newtab";
                    toolbarbutton_0.setAttribute("label", "Новая вкладка");
                    toolbarbutton_0.setAttribute("context", "false");
                    toolbarbutton_0.setAttribute("tooltiptext", "ЛКМ: Открыть новую вкладку\nСКМ: Открыть новую вкладку рядом с текущей\nПКМ: Переместить текущюю вкладку в новое окно");
                    toolbarbutton_0.addEventListener("click", function(event) {
                        if (event.button == 0)
                            win.BrowserOpenTab();
                        else if (event.button == 1)
                            win.openUILinkIn(win.BROWSER_NEW_TAB_URL, "tab", {
                                relatedToCurrent: true, inBackground: false, triggeringPrincipal: Services.scriptSecurityManager.getSystemPrincipal()
                            });
                        else if (event.button == 2) {
                            event.preventDefault();
                            event.stopPropagation();
                            win.gBrowser.replaceTabWithWindow(win.gBrowser.selectedTab);
                        }
                    });
                    toolbarbutton_0.classList.add("toolbarbutton-1", "chromeclass-toolbar-additional");
                    return toolbarbutton_0;
                }
            });
        } catch(e) {}
        try {
            CustomizableUI.createWidget({
                id: "b-close-other-tabs",
                type: "custom",
                label: "Закрыть вкладки",
                tooltiptext: "ЛКМ: Закрыть вкладки перед текущей\nСКМ: Закрыть остальные вкладки текущего сайта\nПКМ: Закрыть вкладки после текущей",
                localized: false,
                showInPrivateBrowsing: showInPrivate,
                onBuild: function(document) {
                    var win = document.defaultView, toolbarbutton_0 = document.createElementNS(ns_xul, "toolbarbutton");
                    toolbarbutton_0.id = "b-close-other-tabs";
                    toolbarbutton_0.setAttribute("label", "Закрыть вкладки");
                    toolbarbutton_0.setAttribute("context", "false");
                    toolbarbutton_0.setAttribute("tooltiptext", "ЛКМ: Закрыть вкладки перед текущей\nСКМ: Закрыть остальные вкладки текущего сайта\nПКМ: Закрыть вкладки после текущей");
                    toolbarbutton_0.addEventListener("click", function(event) {
                        if (event.button == 0)
                            add_toolbar_buttons.closeStartTabs(win);
                        else if (event.button == 1)
                            add_toolbar_buttons.closeTabsDomain(win);
                        else if (event.button == 2) {
                            event.preventDefault();
                            event.stopPropagation();
                            add_toolbar_buttons.closeEndTabs(win);
                        }
                    });
                    toolbarbutton_0.classList.add("toolbarbutton-1", "chromeclass-toolbar-additional");
                    return toolbarbutton_0;
                }
            });
        } catch(e) {}
        try {
            CustomizableUI.createWidget({
                id: "b-close-all-tabs",
                type: "custom",
                label: "Закрыть вкладки, окна",
                tooltiptext: "ЛКМ: Закрыть все вкладки\nShift+ЛКМ: Закрыть другие вкладки\nСКМ: Закрыть другие окна браузера\nПКМ: Закрыть все вкладки текущего сайта",
                localized: false,
                showInPrivateBrowsing: showInPrivate,
                onBuild: function(document) {
                    var win = document.defaultView, toolbarbutton_0 = document.createElementNS(ns_xul, "toolbarbutton");
                    toolbarbutton_0.id = "b-close-all-tabs";
                    toolbarbutton_0.setAttribute("label", "Закрыть вкладки, окна");
                    toolbarbutton_0.setAttribute("context", "false");
                    toolbarbutton_0.setAttribute("tooltiptext", "ЛКМ: Закрыть все вкладки\nShift+ЛКМ: Закрыть другие вкладки\nСКМ: Закрыть другие окна браузера\nПКМ: Закрыть все вкладки текущего сайта");
                    toolbarbutton_0.addEventListener("click", function(event) {
                        if (event.button == 0) {
                            if (!event.shiftKey)
                                add_toolbar_buttons.closeAllTabs(win);
                            else
                                add_toolbar_buttons.closeOtherTabs(win);
                        } else if (event.button == 1)
                            add_toolbar_buttons.closeOtherWindow(win);
                        else if (event.button == 2) {
                            event.preventDefault();
                            event.stopPropagation();
                            add_toolbar_buttons.closeTabsDomain(win, true);
                        }
                    });
                    toolbarbutton_0.classList.add("toolbarbutton-1", "chromeclass-toolbar-additional");
                    return toolbarbutton_0;
                }
            });
        } catch(e) {}
        try {
            CustomizableUI.createWidget({
                id: "b-restart-app",
                type: "custom",
                label: "Перезагрузка",
                tooltiptext: "ЛКМ: Перезапустить приложение\nСКМ: Перезапустить без дополнений\nПКМ: Отключить загрузку содержимого из кеша и перезапустить",
                localized: false,
                showInPrivateBrowsing: showInPrivate,
                onBuild: function(document) {
                    var win = document.defaultView, toolbarbutton_0 = document.createElementNS(ns_xul, "toolbarbutton");
                    toolbarbutton_0.id = "b-restart-app";
                    toolbarbutton_0.setAttribute("label", "Перезагрузка");
                    toolbarbutton_0.setAttribute("context", "false");
                    toolbarbutton_0.setAttribute("tooltiptext", "ЛКМ: Перезапустить приложение\nСКМ: Перезапустить без дополнений\nПКМ: Отключить загрузку содержимого из кеша и перезапустить");
                    toolbarbutton_0.addEventListener("click", function(event) {
                        if (event.button == 0)
                            add_toolbar_buttons.restartMozilla();
                        else if (event.button == 1)
                            win.safeModeRestart();
                        else if (event.button == 2) {
                            event.preventDefault();
                            event.stopPropagation();
                            add_toolbar_buttons.restartMozilla(true);
                        }
                    });
                    toolbarbutton_0.classList.add("toolbarbutton-1", "chromeclass-toolbar-additional");
                    return toolbarbutton_0;
                }
            });
        } catch(e) {}
        try {
            CustomizableUI.createWidget({
                id: "b-about-config",
                type: "custom",
                label: "about:config",
                tooltiptext: "ЛКМ: Открыть about:config\nShift+ЛКМ: Искать содержимое буфера обмена в about:config\nСКМ: Искать содержимое буфера обмена в about:config\nПКМ: Искать выделенное в about:config",
                localized: false,
                showInPrivateBrowsing: showInPrivate,
                onBuild: function(document) {
                    var win = document.defaultView, toolbarbutton_0 = document.createElementNS(ns_xul, "toolbarbutton");
                    toolbarbutton_0.id = "b-about-config";
                    toolbarbutton_0.setAttribute("label", "about:config");
                    toolbarbutton_0.setAttribute("context", "false");
                    toolbarbutton_0.setAttribute("tooltiptext", "ЛКМ: Открыть about:config\nShift+ЛКМ: Искать содержимое буфера обмена в about:config\nСКМ: Искать содержимое буфера обмена в about:config\nПКМ: Искать выделенное в about:config");
                    toolbarbutton_0.addEventListener("click", function(event) {
                        if (event.button == 0) {
                            if (!event.shiftKey)
                                add_toolbar_buttons.LoadURL(win, "about:config");
                            else
                                add_toolbar_buttons.openClipboardConfigTab(win);
                        } else if (event.button == 1)
                            add_toolbar_buttons.openClipboardConfigTab(win);
                        else if (event.button == 2) {
                            event.preventDefault();
                            event.stopPropagation();
                            add_toolbar_buttons.openSelectedConfigTab(win);
                        }
                    });
                    toolbarbutton_0.classList.add("toolbarbutton-1", "chromeclass-toolbar-additional");
                    return toolbarbutton_0;
                }
            });
        } catch(e) {}
        try {
            CustomizableUI.createWidget({
                id: "b-about-downloads",
                type: "custom",
                label: "Загрузки",
                tooltiptext: "ЛКМ: Показать загрузки\nСКМ: Открыть папку загрузок\nПКМ: Открыть последнюю папку загрузок",
                localized: false,
                showInPrivateBrowsing: showInPrivate,
                onBuild: function(document) {
                    var win = document.defaultView, toolbarbutton_0 = document.createElementNS(ns_xul, "toolbarbutton");
                    toolbarbutton_0.id = "b-about-downloads";
                    toolbarbutton_0.setAttribute("label", "Загрузки");
                    toolbarbutton_0.setAttribute("context", "false");
                    toolbarbutton_0.setAttribute("tooltiptext", "ЛКМ: Показать загрузки\nСКМ: Открыть папку загрузок\nПКМ: Открыть последнюю папку загрузок");
                    toolbarbutton_0.addEventListener("click", function(event) {
                        if (event.button == 0)
                            win.DownloadsPanel.showDownloadsHistory();
                        else if (event.button == 1) {
                            try {
                                ServPrefs.getComplexValue("browser.download.dir", Ci.nsIFile).launch();
                            } catch(e) {
                                Services.dirsvc.get("DfltDwnld", Ci.nsIFile).launch();
                            }
                        } else if (event.button == 2) {
                            event.preventDefault();
                            event.stopPropagation();
                            try {
                                ServPrefs.getComplexValue("browser.download.lastDir", Ci.nsIFile).launch();
                            } catch(e) {
                                Services.dirsvc.get("DfltDwnld", Ci.nsIFile).launch();
                            }
                        }
                    });
                    toolbarbutton_0.classList.add("toolbarbutton-1", "chromeclass-toolbar-additional");
                    return toolbarbutton_0;
                }
            });
        } catch(e) {}
        try {
            CustomizableUI.createWidget({
                id: "b-about-about",
                label: "about:about",
                tooltiptext: "Открыть about:about",
                localized: false,
                showInPrivateBrowsing: showInPrivate,
                onClick: function(event) {
                    if (event.button == 0)
                        add_toolbar_buttons.LoadURL(event.target.ownerDocument.defaultView, "about:about");
                    else if (event.button == 1)
                        add_toolbar_buttons.LoadURL(event.target.ownerDocument.defaultView, "about:about", true);
                }
            });
        } catch(e) {}
        try {
            CustomizableUI.createWidget({
                id: "b-clear-data",
                label: "Удалить данные",
                tooltiptext: "Открыть диалоговое окно Удаления личных данных",
                localized: false,
                showInPrivateBrowsing: showInPrivate,
                onCommand: function(event) {
                    add_toolbar_buttons.openSanitizeWin(event.target.ownerDocument.defaultView);
                }
            });
        } catch(e) {}
        try {
            CustomizableUI.createWidget({
                id: "b-preferences",
                label: "Настройки Add Toolbar Buttons",
                tooltiptext: "ЛКМ: Открыть настройки Add Toolbar Buttons\nСКМ: Открыть настройки браузера",
                localized: false,
                showInPrivateBrowsing: showInPrivate,
                onClick: function(event) {
                    if (event.button == 0) {
                        var win = event.target.ownerDocument.defaultView, prefsInfo = `${baseUri}options.xhtml`;
                        if ("gInitialPages" in win && win.gInitialPages.indexOf(prefsInfo) == -1)
                            win.gInitialPages.push(prefsInfo);
                        win.switchToTabHavingURI(prefsInfo, true, {
                            triggeringPrincipal: contExt.principal,
                        });
                    } else if (event.button == 1)
                        event.target.ownerDocument.defaultView.openPreferences();
                }
            });
        } catch(e) {}
        try {
            CustomizableUI.createWidget({
                id: "b-bookmark-nopop",
                type: "custom",
                label: "Быстрая закладка",
                tooltiptext: "ЛКМ: Добавить или удалить закладки без подтверждения\nСКМ: Добавить группу вкладок в закладки\nПКМ: Открыть менеджер Закладок",
                localized: false,
                showInPrivateBrowsing: showInPrivate,
                onBuild: function(document) {
                    var win = document.defaultView, toolbarbutton_0 = document.createElementNS(ns_xul, "toolbarbutton");
                    toolbarbutton_0.id = "b-bookmark-nopop";
                    toolbarbutton_0.setAttribute("label", "Быстрая закладка");
                    toolbarbutton_0.setAttribute("context", "false");
                    toolbarbutton_0.setAttribute("tooltiptext", "ЛКМ: Добавить или удалить закладки без подтверждения\nСКМ: Добавить группу вкладок в закладки\nПКМ: Открыть менеджер Закладок");
                    toolbarbutton_0.addEventListener("click", function(event) {
                        if (event.button == 0)
                            add_toolbar_buttons.bookmarkNoPopup(win);
                        else if (event.button == 1) {
                            if ("showBookmarkPagesDialog" in win.PlacesUIUtils)
                                win.PlacesUIUtils.showBookmarkPagesDialog(win.PlacesCommandHook.uniqueCurrentPages);
                            else if ("bookmarkPages" in win.PlacesCommandHook)
                                win.PlacesCommandHook.bookmarkPages(win.PlacesCommandHook.uniqueCurrentPages);
                            else
                                win.PlacesCommandHook.bookmarkCurrentPages();
                        } else if (event.button == 2) {
                            event.preventDefault();
                            event.stopPropagation();
                            win.PlacesCommandHook.showPlacesOrganizer("BookmarksMenu");
                        }
                    });
                    toolbarbutton_0.classList.add("toolbarbutton-1", "chromeclass-toolbar-additional");
                    return toolbarbutton_0;
                }
            });
        } catch(e) {}
        try {
            CustomizableUI.createWidget({
                id: "b-snap-back",
                type: "custom",
                label: "Полный назад или вперёд",
                tooltiptext: "ЛКМ: Перейти на первую страницу, открытую в этой вкладке\nСКМ: Перейти по введённому адресу в новой вкладке\nПКМ: Перейти на последнюю страницу, открытую в этой вкладке",
                localized: false,
                showInPrivateBrowsing: showInPrivate,
                onBuild: function(document) {
                    var win = document.defaultView, toolbarbutton_0 = document.createElementNS(ns_xul, "toolbarbutton");
                    toolbarbutton_0.id = "b-snap-back";
                    toolbarbutton_0.setAttribute("label", "Полный назад или вперёд");
                    toolbarbutton_0.setAttribute("context", "false");
                    toolbarbutton_0.setAttribute("tooltiptext", "ЛКМ: Перейти на первую страницу, открытую в этой вкладке\nСКМ: Перейти по введённому адресу в новой вкладке\nПКМ: Перейти на последнюю страницу, открытую в этой вкладке");
                    toolbarbutton_0.addEventListener("click", function(event) {
                        if (event.button == 0) {
                            let wn = win.gBrowser.webNavigation;
                            if (wn.canGoBack)
                                wn.gotoIndex(0);
                        } else if (event.button == 1)
                            win.gURLBar.handleCommand(event);
                        else if (event.button == 2) {
                            event.preventDefault();
                            event.stopPropagation();
                            let wn = win.gBrowser.webNavigation;
                            if (wn.canGoForward) {
                                let SessionStore = win.SessionStore || add_toolbar_buttons.SessionStore;
                                wn.gotoIndex(SessionStore.getSessionHistory(win.gBrowser.selectedTab).entries.length - 1);
                            }
                        }
                    });
                    toolbarbutton_0.classList.add("toolbarbutton-1", "chromeclass-toolbar-additional");
                    return toolbarbutton_0;
                }
            });
        } catch(e) {}
        try {
            CustomizableUI.createWidget({
                id: "b-top-page",
                label: "Вверх",
                tooltiptext: "Перейти в начало страницы",
                localized: false,
                showInPrivateBrowsing: showInPrivate,
                onCommand: function(event) {
                    add_toolbar_buttons.sendAsyncMessages(event.target.ownerDocument.defaultView, "scrollTop");
                }
            });
        } catch(e) {}
        try {
            CustomizableUI.createWidget({
                id: "b-bottom-page",
                label: "Вниз",
                tooltiptext: "Перейти к концу страницы",
                localized: false,
                showInPrivateBrowsing: showInPrivate,
                onCommand: function(event) {
                    add_toolbar_buttons.sendAsyncMessages(event.target.ownerDocument.defaultView, "scrollBottom");
                }
            });
        } catch(e) {}
        try {
            CustomizableUI.createWidget({
                id: "b-up-page",
                label: "Вверх",
                tooltiptext: "Прокрутка на одну страницу вверх",
                localized: false,
                showInPrivateBrowsing: showInPrivate,
                onCommand: function(event) {
                    add_toolbar_buttons.sendAsyncMessages(event.target.ownerDocument.defaultView, "scrollPageUp");
                }
            });
        } catch(e) {}
        try {
            CustomizableUI.createWidget({
                id: "b-down-page",
                label: "Вниз",
                tooltiptext: "Прокрутка на одну страницу вниз",
                localized: false,
                showInPrivateBrowsing: showInPrivate,
                onCommand: function(event) {
                    add_toolbar_buttons.sendAsyncMessages(event.target.ownerDocument.defaultView, "scrollPageDown");
                }
            });
        } catch(e) {}
        try {
            CustomizableUI.createWidget({
                id: "b-find-bar",
                type: "custom",
                label: "Поиск",
                tooltiptext: "ЛКМ: Найти текст / Закрыть панель поиска\nСКМ: Поиск на этой странице выделенного\nПКМ: Поиск на этой странице из буфера обмена",
                localized: false,
                showInPrivateBrowsing: showInPrivate,
                onBuild: function(document) {
                    var win = document.defaultView, toolbarbutton_0 = document.createElementNS(ns_xul, "toolbarbutton");
                    toolbarbutton_0.id = "b-find-bar";
                    toolbarbutton_0.setAttribute("label", "Поиск");
                    toolbarbutton_0.setAttribute("context", "false");
                    toolbarbutton_0.setAttribute("tooltiptext", "ЛКМ: Найти текст / Закрыть панель поиска\nСКМ: Поиск на этой странице выделенного\nПКМ: Поиск на этой странице из буфера обмена");
                    toolbarbutton_0.addEventListener("click", function(event) {
                        if (event.button == 0)
                            add_toolbar_buttons.findBarFind(win);
                        else if (event.button == 1)
                            add_toolbar_buttons.findBarCopyPaste(win);
                        else if (event.button == 2) {
                            event.preventDefault();
                            event.stopPropagation();
                            add_toolbar_buttons.findBarPaste(win);
                        }
                    });
                    toolbarbutton_0.classList.add("toolbarbutton-1", "chromeclass-toolbar-additional");
                    return toolbarbutton_0;
                }
            });
        } catch(e) {}
        try {
            CustomizableUI.createWidget({
                id: "b-clear-bar",
                type: "custom",
                label: "Очистить поля адреса и поиска",
                tooltiptext: "ЛКМ: Очистить поле адреса\nСКМ: Очистить поля адреса и поиска\nПКМ: Очистить поле поиска",
                localized: false,
                showInPrivateBrowsing: showInPrivate,
                onBuild: function(document) {
                    var win = document.defaultView, toolbarbutton_0 = document.createElementNS(ns_xul, "toolbarbutton");
                    toolbarbutton_0.id = "b-clear-bar";
                    toolbarbutton_0.setAttribute("label", "Очистить поля адреса и поиска");
                    toolbarbutton_0.setAttribute("context", "false");
                    toolbarbutton_0.setAttribute("tooltiptext", "ЛКМ: Очистить поле адреса\nСКМ: Очистить поля адреса и поиска\nПКМ: Очистить поле поиска");
                    toolbarbutton_0.addEventListener("click", function(event) {
                        if (event.button == 0)
                            add_toolbar_buttons.clearUrlBar(win);
                        else if (event.button == 1)
                            add_toolbar_buttons.clearAllBar(win);
                        else if (event.button == 2) {
                            event.preventDefault();
                            event.stopPropagation();
                            add_toolbar_buttons.clearSearchBar(win);
                        }
                    });
                    toolbarbutton_0.classList.add("toolbarbutton-1", "chromeclass-toolbar-additional");
                    return toolbarbutton_0;
                }
            });
        } catch(e) {}
        try {
            CustomizableUI.createWidget({
                id: "b-paste-and-go",
                type: "custom",
                label: "Вставить и перейти",
                tooltiptext: "ЛКМ: Перейти по адресу из буфера обмена\nСКМ: Перейти по адресу из буфера обмена в новой вкладке\nПКМ: Искать содержимое буфера обмена в новой вкладке",
                localized: false,
                showInPrivateBrowsing: showInPrivate,
                onBuild: function(document) {
                    var win = document.defaultView, toolbarbutton_0 = document.createElementNS(ns_xul, "toolbarbutton");
                    toolbarbutton_0.id = "b-paste-and-go";
                    toolbarbutton_0.setAttribute("label", "Вставить и перейти");
                    toolbarbutton_0.setAttribute("context", "false");
                    toolbarbutton_0.setAttribute("tooltiptext", "ЛКМ: Перейти по адресу из буфера обмена\nСКМ: Перейти по адресу из буфера обмена в новой вкладке\nПКМ: Искать содержимое буфера обмена в новой вкладке");
                    toolbarbutton_0.addEventListener("click", function(event) {
                        if (event.button == 0)
                            add_toolbar_buttons.LoadURLFromClipboard(win);
                        else if (event.button == 1)
                            add_toolbar_buttons.LoadURLFromClipboard(win, true);
                        else if (event.button == 2) {
                            event.preventDefault();
                            event.stopPropagation();
                            add_toolbar_buttons.SearchFromClipboard(win);
                        }
                    });
                    toolbarbutton_0.classList.add("toolbarbutton-1", "chromeclass-toolbar-additional");
                    return toolbarbutton_0;
                }
            });
        } catch(e) {}
        try {
            CustomizableUI.createWidget({
                id: "b-copy-and-go",
                type: "custom",
                label: "Перейти по выделенному",
                tooltiptext: "ЛКМ: Перейти по выделенному\nСКМ: Перейти по выделенному в новой вкладке\nПКМ: Копировать адрес текущей страницы\nShift+ПКМ: Копировать домен текущей страницы",
                localized: false,
                showInPrivateBrowsing: showInPrivate,
                onBuild: function(document) {
                    var win = document.defaultView, toolbarbutton_0 = document.createElementNS(ns_xul, "toolbarbutton");
                    toolbarbutton_0.id = "b-copy-and-go";
                    toolbarbutton_0.setAttribute("label", "Перейти по выделенному");
                    toolbarbutton_0.setAttribute("context", "false");
                    toolbarbutton_0.setAttribute("tooltiptext", "ЛКМ: Перейти по выделенному\nСКМ: Перейти по выделенному в новой вкладке\nПКМ: Копировать адрес текущей страницы\nShift+ПКМ: Копировать домен текущей страницы");
                    toolbarbutton_0.addEventListener("click", function(event) {
                        if (event.button == 0)
                            add_toolbar_buttons.CopyLoadURL(win);
                        else if (event.button == 1)
                            add_toolbar_buttons.CopyLoadURL(win, true);
                        else if (event.button == 2) {
                            event.preventDefault();
                            event.stopPropagation();
                            if (!event.shiftKey)
                                add_toolbar_buttons.CopyCurrentURI(win);
                            else
                                add_toolbar_buttons.CopyDomainURI(win);
                        }
                    });
                    toolbarbutton_0.classList.add("toolbarbutton-1", "chromeclass-toolbar-additional");
                    return toolbarbutton_0;
                }
            });
        } catch(e) {}
        try {
            CustomizableUI.createWidget({
                id: "b-profilefolder",
                type: "custom",
                label: "Открыть папку",
                tooltiptext: "ЛКМ: Папка профиля\nShift+ЛКМ: Дополнение из about:addons\nСКМ: Корневая папка диска\nПКМ: Папка установки",
                localized: false,
                showInPrivateBrowsing: showInPrivate,
                onBuild: function(document) {
                    var win = document.defaultView, toolbarbutton_0 = document.createElementNS(ns_xul, "toolbarbutton");
                    toolbarbutton_0.id = "b-profilefolder";
                    toolbarbutton_0.setAttribute("label", "Открыть папку");
                    toolbarbutton_0.setAttribute("context", "false");
                    toolbarbutton_0.setAttribute("tooltiptext", "ЛКМ: Папка профиля\nShift+ЛКМ: Дополнение из about:addons\nСКМ: Корневая папка диска\nПКМ: Папка установки");
                    toolbarbutton_0.addEventListener("click", function(event) {
                        var dirs;
                        if (event.button == 0) {
                            if (!event.shiftKey) {
                                dirs = Services.dirsvc.get("ProfD", Ci.nsIFile);
                                if (dirs.exists()) dirs.launch();
                            } else
                                add_toolbar_buttons.extensionFolder(win);
                        } else if (event.button == 1) {
                            dirs = Services.dirsvc.get("GreD", Ci.nsIFile);
                            while(dirs.parent)
                                dirs = dirs.parent;
                            dirs.launch();
                        } else if (event.button == 2) {
                            event.preventDefault();
                            event.stopPropagation();
                            dirs = Services.dirsvc.get("GreD", Ci.nsIFile);
                            dirs.launch();
                        }
                    });
                    toolbarbutton_0.classList.add("toolbarbutton-1", "chromeclass-toolbar-additional");
                    return toolbarbutton_0;
                }
            });
        } catch(e) {}
        try {
            CustomizableUI.createWidget({
                id: "b-pass-words",
                label: "Пароли",
                tooltiptext: "Открыть менеджер паролей",
                localized: false,
                showInPrivateBrowsing: showInPrivate,
                onCommand: function(event) {
                    add_toolbar_buttons.viewPasswords(event.target.ownerDocument.defaultView);
                }
            });
        } catch(e) {}
        try {
            CustomizableUI.createWidget({
                id: "b-toggle-styles",
                label: "Переключить стили",
                tooltiptext: "Переключить стили, определенные сайтами",
                localized: false,
                showInPrivateBrowsing: showInPrivate,
                onCommand: function(event) {
                    var win = event.target.ownerDocument.defaultView;
                    try {
                        var styleinfo = ("_getStyleSheetInfo" in win.gPageStyleMenu) ? win.gPageStyleMenu._getStyleSheetInfo(win.gBrowser.selectedBrowser).authorStyleDisabled : win.getMarkupDocumentViewer().authorStyleDisabled;
                        if (styleinfo)
                            win.gPageStyleMenu.switchStyleSheet("");
                        else
                            win.gPageStyleMenu.disableStyle();
                    } catch(e) { }
                }
            });
        } catch(e) {}
        try {
            CustomizableUI.createWidget({
                id: "b-open-console",
                type: "custom",
                label: "Открыть Консоль",
                tooltiptext: "ЛКМ: Открыть Консоль браузера\nСКМ: Открыть Веб-консоль\nПКМ: Открыть Инспектор",
                localized: false,
                showInPrivateBrowsing: showInPrivate,
                onBuild: function(document) {
                    var toolbarbutton_0 = document.createElementNS(ns_xul, "toolbarbutton");
                    toolbarbutton_0.id = "b-open-console";
                    toolbarbutton_0.setAttribute("label", "Открыть Консоль");
                    toolbarbutton_0.setAttribute("context", "false");
                    toolbarbutton_0.setAttribute("tooltiptext", "ЛКМ: Открыть Консоль браузера\nСКМ: Открыть Веб-консоль\nПКМ: Открыть Инспектор");
                    toolbarbutton_0.addEventListener("click", function(event) {
                        if (event.button == 0)
                            document.querySelector("key[id='key_browserConsole']").doCommand();
                        else if (event.button == 1)
                            document.querySelector("key[id='key_webconsole']").doCommand();
                        else if (event.button == 2) {
                            event.preventDefault();
                            event.stopPropagation();
                            document.querySelector("key[id='key_inspector']").doCommand();
                        }
                    });
                    toolbarbutton_0.classList.add("toolbarbutton-1", "chromeclass-toolbar-additional");
                    return toolbarbutton_0;
                }
            });
        } catch(e) {}
        try {
            CustomizableUI.createWidget({
                id: "b-text-to-link",
                type: "custom",
                label: "Текст URL в кликабельные ссылки",
                tooltiptext: "ЛКМ: Превратить текст URL в кликабельные ссылки\nСКМ: Копировать все ссылки на странице\nПКМ: Отключить / Включить кликабельные ссылки",
                localized: false,
                showInPrivateBrowsing: showInPrivate,
                onBuild: function(document) {
                    var win = document.defaultView, toolbarbutton_0 = document.createElementNS(ns_xul, "toolbarbutton");
                    toolbarbutton_0.id = "b-text-to-link";
                    toolbarbutton_0.setAttribute("label", "Текст URL в кликабельные ссылки");
                    toolbarbutton_0.setAttribute("context", "false");
                    toolbarbutton_0.setAttribute("tooltiptext", "ЛКМ: Превратить текст URL в кликабельные ссылки\nСКМ: Копировать все ссылки на странице\nПКМ: Отключить / Включить кликабельные ссылки");
                    toolbarbutton_0.addEventListener("click", function(event) {
                        if (event.button == 0)
                            add_toolbar_buttons.sendAsyncMessages(win, "TextToLink");
                        else if (event.button == 1)
                            add_toolbar_buttons.sendAsyncMessages(win, "CopyAllLinks");
                        else if (event.button == 2) {
                            event.preventDefault();
                            event.stopPropagation();
                            add_toolbar_buttons.sendAsyncMessages(win, "LinkPointerEvents");
                        }
                    });
                    toolbarbutton_0.classList.add("toolbarbutton-1", "chromeclass-toolbar-additional");
                    return toolbarbutton_0;
                }
            });
        } catch(e) {}
        try {
            CustomizableUI.createWidget({
                id: "b-addons-manager",
                label: "Дополнения",
                tooltiptext: "Открыть менеджер дополнений",
                localized: false,
                showInPrivateBrowsing: showInPrivate,
                onCommand: function(event) {
                    event.target.ownerDocument.defaultView.BrowserOpenAddonsMgr();
                }
            });
        } catch(e) {}
        try {
            CustomizableUI.createWidget({
                id: "b-open-file",
                type: "custom",
                label: "Открыть",
                tooltiptext: "ЛКМ: Открыть файл\nСКМ: Открыть userContent\nПКМ: Открыть userChrome",
                localized: false,
                showInPrivateBrowsing: showInPrivate,
                onBuild: function(document) {
                    var win = document.defaultView, toolbarbutton_0 = document.createElementNS(ns_xul, "toolbarbutton");
                    toolbarbutton_0.id = "b-open-file";
                    toolbarbutton_0.setAttribute("label", "Открыть");
                    toolbarbutton_0.setAttribute("context", "false");
                    toolbarbutton_0.setAttribute("tooltiptext", "ЛКМ: Открыть файл\nСКМ: Открыть userContent\nПКМ: Открыть userChrome");
                    toolbarbutton_0.addEventListener("click", function(event) {
                        if (event.button == 0)
                            win.BrowserOpenFileWindow();
                        else if (event.button == 1)
                            add_toolbar_buttons.openUChrmFiles("userContent.css");
                        else if (event.button == 2) {
                            event.preventDefault();
                            event.stopPropagation();
                            add_toolbar_buttons.openUChrmFiles("userChrome.css");
                        }
                    });
                    toolbarbutton_0.classList.add("toolbarbutton-1", "chromeclass-toolbar-additional");
                    return toolbarbutton_0;
                }
            });
        } catch(e) {}
        try {
            CustomizableUI.createWidget({
                id: "b-saveas",
                label: "Сохранить",
                tooltiptext: "Сохранить страницу как...",
                localized: false,
                showInPrivateBrowsing: showInPrivate,
                onCommand: function(event) {
                    var doc = event.target.ownerDocument, win = doc.defaultView;
                    if ("saveBrowser" in win)
                        win.saveBrowser(win.gBrowser.selectedBrowser);
                    else
                       doc.querySelector("command[id='Browser:SavePage']").doCommand();
                }
            });
        } catch(e) {}
        try {
            CustomizableUI.createWidget({
                id: "b-reduce",
                type: "custom",
                label: "Уменьшить",
                tooltiptext: "ЛКМ: Уменьшить размер текста\nСКМ: Увеличить размер текста\nПКМ: Сбросить размер текста",
                localized: false,
                showInPrivateBrowsing: showInPrivate,
                onBuild: function (document) {
                    var win = document.defaultView, toolbarbutton_0 = document.createElementNS(ns_xul, "toolbarbutton");
                    toolbarbutton_0.id = "b-reduce";
                    toolbarbutton_0.setAttribute("label", "Уменьшить");
                    toolbarbutton_0.setAttribute("context", "false");
                    toolbarbutton_0.setAttribute("tooltiptext", "ЛКМ: Уменьшить размер текста\nСКМ: Увеличить размер текста\nПКМ: Сбросить размер текста");
                    toolbarbutton_0.addEventListener("click", function(event) {
                        if (event.button == 0) win.FullZoom.reduce();
                        else if (event.button == 1) win.FullZoom.enlarge();
                        else if (event.button == 2) win.FullZoom.reset();
                    });
                    toolbarbutton_0.classList.add("toolbarbutton-1", "chromeclass-toolbar-additional");
                    return toolbarbutton_0;
                }
            });
        } catch(e) {}
        try {
            CustomizableUI.createWidget({
                id: "b-enlarge",
                type: "custom",
                label: "Увеличить",
                tooltiptext: "ЛКМ: Увеличить размер текста\nСКМ: Уменьшить размер текста\nПКМ: Сбросить размер текста",
                localized: false,
                showInPrivateBrowsing: showInPrivate,
                onBuild: function (document) {
                    var win = document.defaultView, toolbarbutton_0 = document.createElementNS(ns_xul, "toolbarbutton");
                    toolbarbutton_0.id = "b-enlarge";
                    toolbarbutton_0.setAttribute("label", "Увеличить");
                    toolbarbutton_0.setAttribute("context", "false");
                    toolbarbutton_0.setAttribute("tooltiptext", "ЛКМ: Увеличить размер текста\nСКМ: Уменьшить размер текста\nПКМ: Сбросить размер текста");
                    toolbarbutton_0.addEventListener("click", function(event) {
                        if (event.button == 0) win.FullZoom.enlarge();
                        else if (event.button == 1) win.FullZoom.reduce();
                        else if (event.button == 2) win.FullZoom.reset();
                    });
                    toolbarbutton_0.classList.add("toolbarbutton-1", "chromeclass-toolbar-additional");
                    return toolbarbutton_0;
                }
            });
        } catch(e) {}
        try {
            CustomizableUI.createWidget({
                id: "b-loads-favicons",
                type: "custom",
                label: "Восстановить фавиконки",
                tooltiptext: "Восстановить фавиконки закладок",
                localized: false,
                showInPrivateBrowsing: showInPrivate,
                onBuild: function(document) {
                    var toolbarbutton_0 = document.createElementNS(ns_xul, "toolbarbutton");
                    toolbarbutton_0.id = "b-loads-favicons";
                    toolbarbutton_0.setAttribute("label", "Восстановить фавиконки");
                    toolbarbutton_0.setAttribute("tooltiptext", "Восстановить фавиконки закладок");
                    toolbarbutton_0.setAttribute("activated", !add_toolbar_buttons.favrunning);
                    toolbarbutton_0.addEventListener("command", function() {
                        add_toolbar_buttons.faviconsBook();
                    });
                    toolbarbutton_0.classList.add("toolbarbutton-1", "chromeclass-toolbar-additional");
                    return toolbarbutton_0;
                }
            });
        } catch(e) {}
        [
            "permissions.default.image", "image.animation_mode", "javascript.enabled", "media.autoplay.enabled", "media.autoplay.default", "browser.zoom.full", "network.cookie.cookieBehavior", "network.proxy.type"
        ].forEach(pref => {
            var type = ServPrefs.getPrefType(pref);
            if (type != ServPrefs.PREF_INVALID)
                ServPrefs.addObserver(pref, this, false);
        });
        ServPrefs.addObserver("extensions.add_toolbar_buttons.obs.", this, false);
    },
    loadButtonStyle: function(win) {
        try {
            var utils = win.windowUtils || win.QueryInterface(Ci.nsIInterfaceRequestor).getInterface(Ci.nsIDOMWindowUtils);
            utils.loadSheet(this.styleURI, utils.USER_SHEET);
        } catch(ex) {
            console.error(ex);
        }
    },
    removeButtonStyle: function(win) {
        try {
            var utils = win.windowUtils || win.QueryInterface(Ci.nsIInterfaceRequestor).getInterface(Ci.nsIDOMWindowUtils);
            utils.removeSheet(this.styleURI, utils.USER_SHEET);
        } catch(ex) {
            console.error(ex);
        }
    },
    restartMozilla: function(nocache = false) {
        var cancelQuit = Cc["@mozilla.org/supports-PRBool;1"].createInstance(Ci.nsISupportsPRBool);
        Services.obs.notifyObservers(cancelQuit, "quit-application-requested", "restart");
        if (cancelQuit.data)
            return false;
        if (nocache)
            Services.appinfo.invalidateCachesOnRestart();
        var restart = Services.startup;
        restart.quit(restart.eAttemptQuit | restart.eRestart);
    },
    openUChrmFiles: function(filename) {
        try {
            var file = Services.dirsvc.get("UChrm", Ci.nsIFile);
            file.append(filename);
            if (file.exists())
                file.launch();
            else
                this.AlertsService.showAlertNotification(`${baseUri}svg/icon.svg`, filename, "Файл отсутствует!", false);
        } catch(e) { }
    },
    bookmarkNoPopup: function(win) {
        if (this.bookmarksInsertRemove)
            return;
        this.bookmarksInsertRemove = true;
        var bookmarks = PlacesUtils.bookmarks, url = win.gBrowser.selectedBrowser.currentURI.spec;
        bookmarks.search({url}).then(async array => {
            if (!array.length)
                try {
                    await bookmarks.insert({
                        url: Services.io.newURI(url),
                        title: (win.gBrowser.contentTitle || win.gBrowser.selectedTab.label || url),
                        parentGuid: [() => bookmarks.menuGuid, () => bookmarks.toolbarGuid, () => bookmarks.unfiledGuid][this.ExtensionPrefBranch.getIntPref("bookmarksparentguid")](),
                        index: (!this.ExtensionPrefBranch.getBoolPref("bookmarksindex") ? bookmarks.DEFAULT_INDEX : 0)
                    });
                } catch(e) {}
            else
                try {
                    await bookmarks.remove(array);
                } catch(e) {}
            this.bookmarksInsertRemove = false;
        });
    },
    closeStartTabs: function(win) {
        var ctab = win.gBrowser.selectedTab, tabs;
        if (ctab.multiselected)
            tabs = win.gBrowser.visibleTabs.filter(tab => !tab.multiselected && !tab.pinned);
        else
            tabs = win.gBrowser.visibleTabs.filter(tab => !tab.pinned);
        var index = tabs.indexOf(ctab);
        tabs = tabs.slice(0, (index != -1) ? index : tabs.length);
        tabs.forEach(tab => {
            win.gBrowser.removeTab(tab);
        });
    },
    closeEndTabs: function(win) {
        var ctab = win.gBrowser.selectedTab, tabs;
        if (ctab.multiselected)
            tabs = win.gBrowser.visibleTabs.filter(tab => !tab.multiselected && !tab.pinned);
        else
            tabs = win.gBrowser.visibleTabs.filter(tab => !tab.pinned);
        var index = tabs.indexOf(ctab);
        tabs = tabs.slice((index != -1) ? (index + 1) : 0, tabs.length);
        tabs.forEach(tab => {
            win.gBrowser.removeTab(tab);
        });
    },
    closeOtherTabs: function(win) {
        win.gBrowser.removeAllTabsBut(win.gBrowser.selectedTab);
    },
    closeOtherWindow: function(win) {
        for (let w of contExt.windowManager.getAll()) {
            if (w.window != win)
                w.window.close();
        }
    },
    addTab: function(win, url, params = {}) {
        params.triggeringPrincipal = Services.scriptSecurityManager.getSystemPrincipal();
        params.relatedToCurrent = true;
        return win.gBrowser.addTab(url, params);
    },
    closeAllTabs: function(win) {
        win.gBrowser.removeAllTabsBut(this.addTab(win, win.BROWSER_NEW_TAB_URL));
    },
    prefToggleString: function(pref, next) {
        var curindex = next.indexOf(ServPrefs.getCharPref(pref)), maxindex = next.length - 1;
        ServPrefs.setCharPref(pref, next[(curindex == maxindex || curindex == -1) ? 0 : curindex + 1]);
    },
    prefToggleNumber: function(pref, next) {
        ServPrefs.setIntPref(pref, next[ServPrefs.getIntPref(pref)]);
    },
    getViewPasswordsUrl: async function(win) {
        var passwordsUrl = "chrome://passwordmgr/content/passwordManager";
        try {
            await win.fetch(`${passwordsUrl}.xhtml`, {
                method: "HEAD"
            });
            return `${passwordsUrl}.xhtml`;
        } catch (e) {}
        try {
            await win.fetch(`${passwordsUrl}.xul`, {
                method: "HEAD"
            });
            return `${passwordsUrl}.xul`;
        } catch (e) {}
        return false;
    },
    viewPasswords: async function(win) {
        var passwordsUrl = this.passwordsUrl = await this.getViewPasswordsUrl(win);
        if (!passwordsUrl) {
            this.viewPasswords = function(win) {
                var uri = win.gBrowser.selectedBrowser.currentURI;
                try {
                    let _uri;
                    if (_uri = win.ReaderMode.getOriginalUrl(uri.spec))
                        uri = Services.io.newURI(_uri);
                } catch(e) {}
                var scheme = uri.scheme;
                uri = this.getETDL(uri);
                try {
                    uri = Services.io.newURI(`${scheme}://${uri}`).displayHost;
                } catch (e) {}
                var params = new win.URLSearchParams({
                    ...(uri && { filter: uri }),
                });
                var separator = params.toString() ? "?" : "";
                win.gBrowser.selectedTab = this.addTab(win, `about:logins${separator}${params}`);
            };
        } else {
            this.viewPasswords = function(win) {
                var uri = win.gBrowser.selectedBrowser.currentURI;
                try {
                    let _uri;
                    if (_uri = win.ReaderMode.getOriginalUrl(uri.spec))
                        uri = Services.io.newURI(_uri);
                } catch(e) {}
                var scheme = uri.scheme;
                uri = this.getETDL(uri);
                try {
                    uri = Services.io.newURI(`${scheme}://${uri}`).displayHost;
                } catch (e) {}
                var _win = Services.wm.getMostRecentWindow("Toolkit:PasswordManager");
                var _setFilter = () => {
                    var filter = _win.document.querySelector("#filter");
                    if (!filter) return;
                    filter.value = uri;
                    filter.focus();
                    filter.dispatchEvent(new _win.Event("input", { bubbles: true }));
                };
                if (_win) {
                    _win.focus();
                    _setFilter();
                } else {
                    _win = win.openDialog(this.passwordsUrl, "Toolkit:PasswordManager", "chrome,dialog=no,centerscreen,resizable");
                    _win.addEventListener("DOMContentLoaded", function DOMLoad() {
                        _setFilter();
                    }, { once: true });
                }
            };
        }
        this.viewPasswords(win);
    },
    extensionFolder: function(win) {
        try {
            var browser = win.content.document.querySelector("browser#html-view-browser");
            var doc = browser ? browser.contentDocument : win.content.document;
            var _addon = doc.querySelector("richlistitem.addon[current='true'], addon-card[expanded='true']");
            if (_addon) {
                var value = _addon.hasAttribute("value") ? _addon.getAttribute("value") : _addon.addon.id
                var file = Services.dirsvc.get("ProfD", Ci.nsIFile);
                file.append("extensions");
                file.append(value + ".xpi");
                if (file.exists())
                    file.launch();
            } else
                this.extensionFolderAlert();
        } catch(e) {
            if ("BrowserOpenAddonsMgr" in win) {
                win.BrowserOpenAddonsMgr();
                this.extensionFolderAlert();
            }
        }
    },
    extensionFolderAlert: function() {
        try {
            this.AlertsService.showAlertNotification(`${baseUri}svg/icon.svg`, "Дополнение из about:addons", "Выберите дополнение и снова нажмите кнопку", false);
        } catch(e) {}
    },
    checkBrowserReload: function(win) {
        if (this.ExtensionPrefBranch.getBoolPref("doreload")) {
            win.BrowserReloadSkipCache();
        }
    },
    cssFileToUserContent: function(aCss, toggle) {
        var sss = this.styleSS, url = Services.io.newURI("data:text/css;charset=utf-8," + encodeURIComponent(aCss));
        var sheetReg = sss.sheetRegistered(url, sss.USER_SHEET);
        if (!toggle && !sheetReg)
            sss.loadAndRegisterSheet(url, sss.USER_SHEET);
        else if (toggle && sheetReg)
            sss.unregisterSheet(url, sss.USER_SHEET);
    },
    LoadURL: function(win, url, newtab = false) {
        if (newtab || this.ExtensionPrefBranch.getBoolPref("newtab"))
            win.gBrowser.selectedTab = this.addTab(win, url);
        else
            win.openUILinkIn(url, "current", {
                triggeringPrincipal: Services.scriptSecurityManager.getSystemPrincipal()
            });
    },
    openSanitizeWin: function(win) {
        if ("Sanitizer" in win)
            win.Sanitizer.showUI(win);
        else
            Cc["@mozilla.org/browser/browserglue;1"].getService(Ci.nsIBrowserGlue).sanitize(win);
    },
    readFromClipboard: function(win) {
        var url = "";
        try {
            var trans = Cc["@mozilla.org/widget/transferable;1"].createInstance(Ci.nsITransferable);
            var contxt = ("docShell" in win) ? win.docShell.QueryInterface(Ci.nsILoadContext) : win.QueryInterface(Ci.nsIInterfaceRequestor).getInterface(Ci.nsIWebNavigation).QueryInterface(Ci.nsILoadContext);
            trans.init(contxt);
            trans.addDataFlavor("text/unicode");
            var clipboard = Services.clipboard;
            clipboard.getData(trans, clipboard.kGlobalClipboard);
            var data = {};
            trans.getTransferData("text/unicode", data, {});
            if (data.value) {
                data = data.value.QueryInterface(Ci.nsISupportsString);
                url = data.data;
            }
        } catch (ex) { }
        return url;
    },
    CopyLoadURL: function(win, newtab = false) {
        var clip = this.readFromClipboard(win);
        win.goDoCommand("cmd_copy");
        win.setTimeout(() => {
            var url = this.readFromClipboard(win);
            this.LoadURL(win, url, newtab);
            if (clip && clip != url)
                this.ClipboardHelper.copyString(clip);
        }, 100);
    },
    prefToggleStatus: function(pref) {
        ServPrefs.setBoolPref(pref, !ServPrefs.getBoolPref(pref));
    },
    extensionPrefToggleStatus: function(pref) {
        var prefs = this.ExtensionPrefBranch;
        prefs.setBoolPref(pref, !prefs.getBoolPref(pref));
    },
    getETDL: function(uri) {
        var eTLD;
        try {
            eTLD = Services.eTLD.getBaseDomain(uri);
        } catch (e) {
            eTLD = uri.asciiHost;
        }
        return eTLD;
    },
    CopyCurrentURI: function(win) {
        var uri = win.gBrowser.selectedBrowser.currentURI;
        try {
            let _uri;
            if (_uri = win.ReaderMode.getOriginalUrl(uri.spec))
                uri = Services.io.newURI(_uri);
        } catch(e) {}
        uri = uri.displaySpec;
        try {
            uri = decodeURIComponent(uri);
        } catch(e) {}
        this.ClipboardHelper.copyString(uri);
        try {
            this.AlertsService.showAlertNotification(`${baseUri}svg/icon.svg`, "Адрес текущей страницы в буфере обмена!", uri, false);
        } catch(e) {}
    },
    CopyDomainURI: function(win) {
        var uri = win.gBrowser.selectedBrowser.currentURI;
        try {
            let _uri;
            if (_uri = win.ReaderMode.getOriginalUrl(uri.spec))
                uri = Services.io.newURI(_uri);
        } catch(e) {}
        var scheme = uri.scheme;
        uri = this.getETDL(uri);
        try {
            uri = Services.io.newURI(`${scheme}://${uri}`).displayHost;
        } catch (e) {
            return;
        }
        try {
            uri = decodeURIComponent(uri);
        } catch (e) {}
        this.ClipboardHelper.copyString(uri);
        try {
            this.AlertsService.showAlertNotification(`${baseUri}svg/icon.svg`, "Домен текущей страницы в буфере обмена!", uri, false);
        } catch(e) {}
    },
    LoadURLFromClipboard: function(win, newtab = false) {
        this.LoadURL(win, this.readFromClipboard(win), newtab);
    },
    SearchFromClipboard: function(win) {
        var engine = Services.search.getVisibleEngines();
        if ("then" in engine) {
            engine.then(eng => {
                this._SearchFromClipboard(win, eng);
            });
        } else {
            this._SearchFromClipboard(win, engine);
        }
    },
    _SearchFromClipboard: function(win, eng) {
        var data = this.readFromClipboard(win);
        var submission = eng[0].getSubmission(data, null);
        if (!submission) return;
        win.gBrowser.selectedTab = this.addTab(win, submission.uri.spec);
    },
    clearUrlBar: function(win) {
        var urlbar = win.gURLBar || win.document.querySelector("#urlbar");
        if (!urlbar) return;
        urlbar.value = "";
        urlbar.focus();
    },
    clearSearchBar: function(win, nofocus = false) {
        var searchbar = win.document.querySelector("#searchbar");
        if (!searchbar) return;
        searchbar.textbox.value = "";
        if (!nofocus)
            searchbar.textbox.focus();
    },
    clearAllBar: function(win) {
        this.clearSearchBar(win, true);
        this.clearUrlBar(win);
    },
    _findBarFind: function(win, findbar) {
        if (findbar.hidden) findbar.onFindCommand();
        else findbar.close();
    },
    findBarFind: function(win) {
        var findbar = win.gFindBar;
        if (!findbar) {
            try {
                win.gBrowser.getFindBar().then(bar => {
                    this._findBarFind(win, bar);
                });
            } catch(e) {}
            return;
        }
        this._findBarFind(win, findbar);
    },
    _findBarCopyPaste: function(win, findbar) {
        var clip = this.readFromClipboard(win);
        win.goDoCommand("cmd_copy");
        win.setTimeout(() => {
            var val = this.readFromClipboard(win);
            if (findbar.hidden) {
                findbar.onFindCommand();
                findbar._findField.value = val;
                findbar._find(val);
            } else {
                findbar._findField.value = val;
                findbar._find(val);
            }
            if (clip && clip != val)
                this.ClipboardHelper.copyString(clip);
        }, 100);
    },
    findBarCopyPaste: function(win) {
        var findbar = win.gFindBar;
        if (!findbar) {
            try {
                win.gBrowser.getFindBar().then(bar => {
                    this._findBarCopyPaste(win, bar);
                });
            } catch(e) {}
            return;
        }
        this._findBarCopyPaste(win, findbar);
    },
    _findBarPaste: function(win, findbar) {
        var val = this.readFromClipboard(win);
        if (findbar.hidden) {
            findbar.onFindCommand();
            findbar._findField.value = val;
            findbar._find(val);
        } else {
            findbar._findField.value = val;
            findbar._find(val);
        }
    },
    findBarPaste: function(win) {
        var findbar = win.gFindBar;
        if (!findbar) {
            try {
                win.gBrowser.getFindBar().then(bar => {
                    this._findBarPaste(win, bar);
                });
            } catch(e) {}
            return;
        }
        this._findBarPaste(win, findbar);
    },
    openClipboardConfigTab: function(win, clip = "", copy) {
        var filter = this.readFromClipboard(win), nowarn = false, pref, type = ServPrefs.PREF_BOOL;
        if (copy && clip != filter)
            this.ClipboardHelper.copyString(clip);
        if ((ServPrefs.getPrefType(pref = "browser.aboutConfig.showWarning") == type || ServPrefs.getPrefType(pref = "general.warnOnAboutConfig") == type) && ServPrefs.getBoolPref(pref)) {
            ServPrefs.setBoolPref(pref, false);
            nowarn = true;
        }
        var browser = win.gBrowser.getBrowserForTab(win.gBrowser.selectedTab = this.addTab(win, "about:config"));
        browser.addEventListener("pageshow", function show() {
            var doc = this.contentDocument;
            var input = (doc && doc.querySelector("input#about-config-search, textbox#textbox"));
            if (input && filter) {
                input.value = filter;
                input.focus();
                input.dispatchEvent(new doc.defaultView.Event("input", { bubbles: true }));
            }
            if (nowarn)
                win.setTimeout(() => {
                    ServPrefs.setBoolPref(pref, true);
                }, 200);
        }, { once: true });
    },
    openSelectedConfigTab: function(win) {
        var clip = this.readFromClipboard(win);
        win.goDoCommand("cmd_copy");
        win.setTimeout(() => {
            this.openClipboardConfigTab(win, clip, true);
        }, 100);
    },
    getViewCookies: async function(win) {
        var viewCookiesUrl = "chrome://browser/content/preferences/dialogs/siteDataSettings.xhtml";
        try {
            await win.fetch(viewCookiesUrl, {
                method: "HEAD"
            });
            return viewCookiesUrl;
        } catch (e) {}
        viewCookiesUrl = "chrome://browser/content/preferences/siteDataSettings";
        try {
            await win.fetch(`${viewCookiesUrl}.xhtml`, {
                method: "HEAD"
            });
            return `${viewCookiesUrl}.xhtml`;
        } catch (e) {}
        try {
            await win.fetch(`${viewCookiesUrl}.xul`, {
                method: "HEAD"
            });
            return `${viewCookiesUrl}.xul`;
        } catch (e) {}
        return false;
    },
    viewCookies: async function(win) {
        if (!("SiteDataManager" in win))
            return;
        this.viewCookiesUrl = await this.getViewCookies(win);
        this.viewCookies = function(win) {
            var uri = win.gBrowser.selectedBrowser.currentURI;
            try {
                let _uri;
                if (_uri = win.ReaderMode.getOriginalUrl(uri.spec))
                    uri = Services.io.newURI(_uri);
            } catch(e) {}
            uri = this.getETDL(uri);
            var _win = Services.wm.getMostRecentWindow("Browser:SiteDataSettings");
            var _setFilter = () => {
                var filter = _win.document.querySelector("#searchBox");
                if (!filter) return;
                filter.value = uri;
                filter.focus();
                filter.dispatchEvent(new _win.Event("input", { bubbles: true }));
            };
            if (_win) {
                _win.focus();
                _setFilter();
            } else {
                win.SiteDataManager.updateSites().then(() => {
                    _win = win.openDialog(this.viewCookiesUrl, "Browser:SiteDataSettings", "chrome,dialog=no,centerscreen,resizable");
                    _win.addEventListener("DOMContentLoaded", function DOMLoad() {
                        _setFilter();
                    }, { once: true });
                });
            }
        };
        this.viewCookies(win);
    },
    toggleTheProxy: function() {
        var proxyState = ServPrefs.getIntPref("network.proxy.type");
        var toggleproxy = this.ExtensionPrefBranch.getIntPref("toggleproxy");
        var toggleproxy2 = this.ExtensionPrefBranch.getIntPref("toggleproxy2");
        if (proxyState == toggleproxy2)
            ServPrefs.setIntPref("network.proxy.type", toggleproxy);
        else
            ServPrefs.setIntPref("network.proxy.type", toggleproxy2);
    },
    setProxyMenuItem: function(event, item) {
        var proxyState = ServPrefs.getIntPref("network.proxy.type");
        for (var menuitem in item.childNodes) {
            var childNode = item.childNodes[menuitem];
            if (+childNode.getAttribute("value") == proxyState) {
                childNode.setAttribute("checked", "true");
                return;
            }
        }
    },
    setProxyValue: function(event) {
        ServPrefs.setIntPref("network.proxy.type", +event.originalTarget.getAttribute("value"));
    },
    _openProxyWin: function(win, url) {
        var _win = Services.wm.getMostRecentWindow("aTaB:ProxyWin");
        if (_win)
            _win.focus();
        else {
            _win = win.openDialog(url, "_blank", "chrome,dialog=no,centerscreen,resizable");
            var DOMLoad = () => {
                _win.document.documentElement.setAttribute("type", "prefwindow");
                _win.document.documentElement.setAttribute("windowtype", "aTaB:ProxyWin");
                if (!this.proxyWinLoadStyle)
                    return;
                var style = "data:text/css;charset=utf-8," + encodeURIComponent(`
                    #proxy-grid,
                    #dnsOverHttps-grid {
                        display: grid;
                        grid-template-columns: auto 1fr;
                        align-items: center;
                    }
                    #proxy-grid > .thin {
                        grid-column-end: 3;
                        height: 20px;
                    }
                    #dnsOverHttps-grid.custom-container-hidden #networkCustomDnsOverHttpsInputLabelContainer,
                    #dnsOverHttps-grid.custom-container-hidden #networkCustomDnsOverHttpsInput {
                        display: none;
                    }
                `);
                _win.windowUtils.loadSheetUsingURIString(style, _win.windowUtils.AUTHOR_SHEET);
            };
            _win.addEventListener("DOMContentLoaded", DOMLoad, { once: true });
            _win.opener = win;
            _win.opener.gSubDialog = {
                _dialogs: []
            };
        }
    },
    getOpenProxyWin: async function(win) {
        var openProxyWinUrl = "chrome://browser/content/preferences/dialogs/connection.xhtml";
        try {
            await win.fetch(openProxyWinUrl, {
                method: "HEAD"
            });
            return openProxyWinUrl;
        } catch (e) {}
        openProxyWinUrl = "chrome://browser/content/preferences/connection";
        try {
            await win.fetch(`${openProxyWinUrl}.xhtml`, {
                method: "HEAD"
            });
            this.proxyWinLoadStyle = true;
            return `${openProxyWinUrl}.xhtml`;
        } catch (e) {}
        try {
            await win.fetch(`${openProxyWinUrl}.xul`, {
                method: "HEAD"
            });
            return `${openProxyWinUrl}.xul`;
        } catch (e) {}
        return false;
    },
    openProxyWin: async function(win) {
        this.openProxyWinUrl = await this.getOpenProxyWin(win);
        this.openProxyWin = function(win) {
            this._openProxyWin(win, this.openProxyWinUrl);
        };
        this.openProxyWin(win);
    },
    loadsScript: function() {
        this.receiveMessage = function(msg) {
            var mdf = msg.data.func;
            if (mdf == "EnableJavascript")
                add_toolbar_buttons.checkBrowserReload(this.win);
            else if (mdf == "DisableImages")
                add_toolbar_buttons.checkBrowserReload(this.win);
            else if (mdf == "EnableImages")
                add_toolbar_buttons.checkBrowserReload(this.win);
            else if (mdf == "AllLinksCopy") {
                add_toolbar_buttons.ClipboardHelper.copyString(msg.data.links);
                try {
                    add_toolbar_buttons.AlertsService.showAlertNotification(`${baseUri}svg/icon.svg`, "Копирование ссылок", msg.data.count + " ссылок в буфере обмена!", false);
                } catch(e) {}
            } else if (mdf == "unloadFrameScript") {
                this.mm.removeMessageListener("responseAddsFrameScript", this);
                delete this.mm.addsframescript;
            }
        };
        this.addMessage = function(win, mm) {
            this.win = win;
            this.mm = mm;
            mm.addMessageListener("responseAddsFrameScript", this, true);
            mm.loadFrameScript("data:application/javascript;charset=utf-8," + add_toolbar_buttons.framescript, false);
            Object.defineProperty(mm, "addsframescript", {
                value: true,
                writable: false,
                configurable: true,
                enumerable: false
            });
        };
    },
    sendAsyncMessages: function(win, str) {
        var mm = win.gBrowser.selectedBrowser.messageManager;
        if (!mm.addsframescript) {
            let loadsScript = new this.loadsScript();
            loadsScript.addMessage(win, mm);
        }
        mm.sendAsyncMessage("requestAddsFrameScript", {func: str});
    },
    closeTabsDomain: function(win, select = false) {
        var gdu = win.gBrowser.selectedBrowser.currentURI;
        try {
            let _gdu;
            if (_gdu = win.ReaderMode.getOriginalUrl(gdu.spec))
                gdu = Services.io.newURI(_gdu);
        } catch(e) {}
        gdu = this.getETDL(gdu);
        if (!gdu) return;
        var selTab = win.gBrowser.selectedTab;
        win.gBrowser.visibleTabs.forEach(tab => {
            var sel = select ? true : (tab != selTab);
            if (!tab.pinned && sel) {
                var uri = tab.linkedBrowser.currentURI;
                try {
                    let _uri;
                    if (_uri = win.ReaderMode.getOriginalUrl(uri.spec))
                        uri = Services.io.newURI(_uri);
                } catch(e) {}
                if (gdu == this.getETDL(uri))
                    win.gBrowser.removeTab(tab);
            }
        });
    },
    faviconsBook: function() {
        if (this.favrunning) return;
        this.favrunning = true;
        this.callWithEachWindow("b-loads-favicons", false);
        var urlsList = [];
        var forFolderContent = folderId => {
            var folder = PlacesUtils.getFolderContents(folderId).root;
            folder.QueryInterface(Ci.nsINavHistoryContainerResultNode);
            folder.containerOpen = true;
            for (var i = 0; i < folder.childCount; i++) {
                var child = folder.getChild(i);
                if (PlacesUtils.nodeIsFolder(child))
                    forFolderContent(child.bookmarkGuid);
                else if (/^(?:https?|file):/i.test(child.uri))
                    urlsList.push(child.uri);
            }
            folder.containerOpen = false;
        };
        forFolderContent(PlacesUtils.bookmarks.rootGuid);
        Promise.all(urlsList.map(this.getFaviconForPage)).then(results => this.sliceResults(results.filter(url => url !== null)));
    },
    sliceResults: function(results) {
        var maxlength = results.length, maxrequests = this.ExtensionPrefBranch.getIntPref("maxrequests");
        this.favmaxtimeout = this.ExtensionPrefBranch.getIntPref("maxtimeout") * 1000;
        var forPageFavicon = (start, end) => {
            var endlength = maxlength - end, startend;
            if (endlength > 0)
                startend = results.slice(start, end);
            else
                startend = results.slice(start, maxlength);
            Promise.all(startend.map(this.getPageFavicon, this)).then(() => {
                if (endlength > 0)
                    forPageFavicon(end, end + maxrequests);
                else {
                    this.favrunning = false;
                    this.callWithEachWindow("b-loads-favicons", true);
                    if (this.ExtensionPrefBranch.getBoolPref("alertnotification")) {
                        try {
                            this.AlertsService.showAlertNotification(`${baseUri}svg/icon.svg`, "Поиск фавиконок", "Завершено!", false);
                        } catch(e) {}
                    }
                }
            });
        };
        forPageFavicon(0, maxrequests);
    },
    getFaviconForPage: function(siteURI) {
        return new Promise(resolve => {
            try {
                siteURI =  Services.io.newURI(siteURI);
            } catch(e) {
                resolve(null);
            }
            PlacesUtils.favicons.getFaviconURLForPage(siteURI, uri => {
                if (uri === null)
                    resolve(siteURI);
                else
                    resolve(null);
            });
        });
    },
    getPageFavicon: function(siteURI) {
        return new Promise(resolve => {
            var req = new XMLHttpRequest();
            if (!req) {
                resolve();
                return;
            }
            req.mozBackgroundRequest = true;
            req.open("GET", siteURI.spec, true);
            req.responseType = "document";
            req.overrideMimeType("text/html");
            req.timeout = this.favmaxtimeout;
            req.onload = () => {
                resolve();
                var favURI = `${siteURI.prePath}/favicon.ico`, doc = req.responseXML;
                if (doc !== null) {
                    let link = doc.querySelector("head link[href][rel~='icon']");
                    if (link !== null)
                        favURI = link.href;
                }
                try {
                    favURI = Services.io.newURI(favURI);
                } catch(e) {
                    return;
                }
                PlacesUtils.favicons.setAndFetchFaviconForPage(siteURI, favURI, false, PlacesUtils.favicons.FAVICON_LOAD_NON_PRIVATE, null, Services.scriptSecurityManager.getSystemPrincipal());
            };
            req.onabort = () => {
                resolve();
            };
            req.onerror = () => {
                resolve();
                req.abort();
            };
            req.ontimeout = () => {
                resolve();
                req.abort();
            };
            req.send(null);
        });
    },
    observe: function(aSubject, aTopic, aData) {
        if (aData == "permissions.default.image") {
            let permissions_default_image = this.permissions_default_image = ServPrefs.getIntPref(aData);
            this.callWithEachWindow("b-image-toggle", permissions_default_image);
        } else if (aData == "extensions.add_toolbar_buttons.obs.animation") {
            let anim_css = this.anim_css = ServPrefs.getBoolPref(aData);
            this.cssFileToUserContent(this.animationCSS, anim_css);
            this.callWithEachWindow("b-stop-animation", anim_css);
        } else if (aData == "extensions.add_toolbar_buttons.obs.animfunc") {
            this.cssFileToUserContent(this.animationCSS, true);
            this.anim_func = ServPrefs.getBoolPref(aData);
            if (!this.ExtensionPrefBranch.getBoolPref("obs.animation"))
                this.cssFileToUserContent(this.animationCSS, false);
        } else if (aData == "image.animation_mode") {
            let image_animation_mode = this.image_animation_mode = ServPrefs.getCharPref(aData);
            this.callWithEachWindow("b-stop-animation", image_animation_mode.substring(0, 3), true);
        } else if (aData == "media.autoplay.enabled") {
            let media_autoplay_enabled = this.media_autoplay_enabled = ServPrefs.getBoolPref(aData);
            this.callWithEachWindow("b-autoplay", media_autoplay_enabled);
        } else if (aData == "media.autoplay.default") {
            let media_autoplay_default = this.media_autoplay_default = ServPrefs.getIntPref(aData);
            this.callWithEachWindow("b-autoplay", media_autoplay_default);
        } else if (aData == "javascript.enabled") {
            let javascript_enabled = this.javascript_enabled = ServPrefs.getBoolPref(aData);
            this.callWithEachWindow("b-javascript", javascript_enabled);
        } else if (aData == "network.cookie.cookieBehavior") {
            let network_cookie_cookieBehavior = this.network_cookie_cookieBehavior = ServPrefs.getIntPref(aData);
            this.callWithEachWindow("b-cookie-toggle", network_cookie_cookieBehavior);
        } else if (aData == "browser.zoom.full") {
            let browser_zoom_full = this.browser_zoom_full = ServPrefs.getBoolPref(aData);
            this.callWithEachWindow("b-zoom-toggle", browser_zoom_full);
        } else if (aData == "network.proxy.type") {
            let network_proxy_type = this.network_proxy_type = ServPrefs.getIntPref(aData);
            this.callWithEachWindow("toolbaritem-b-toggle-proxy", network_proxy_type);
        }
    },
    callWithEachWindow: function(buttonID, value, badge) {
        var atr = !badge ? "activated" : "badge";
        for (let win of contExt.windowManager.getAll()) {
            try {
                let button = win.window.document.querySelector(`#${buttonID}`) || win.window.gNavToolbox.palette.querySelector(`#${buttonID}`);
                button.setAttribute(atr, value);
            } catch(e) {}
        }
    },
    GetPref: function(name) {
        var type = ServPrefs.getPrefType(name);
        switch (type) {
          case ServPrefs.PREF_STRING:
            return ServPrefs.getCharPref(name);
          case ServPrefs.PREF_INT:
            return ServPrefs.getIntPref(name);
          case ServPrefs.PREF_BOOL:
            return ServPrefs.getBoolPref(name);
        }
    },
    SetPref: function(name, value) {
        var type = ServPrefs.getPrefType(name);
        switch (type) {
          case ServPrefs.PREF_STRING:
            ServPrefs.setCharPref(name, value);
            break;
          case ServPrefs.PREF_INT:
            ServPrefs.setIntPref(name, value);
            break;
          case ServPrefs.PREF_BOOL:
            ServPrefs.setBoolPref(name, value);
            break;
        }
    },
    uninit: function() {
        if (this.initialized) {
            [
                "permissions.default.image", "image.animation_mode", "javascript.enabled", "media.autoplay.enabled", "media.autoplay.default", "browser.zoom.full", "network.cookie.cookieBehavior", "network.proxy.type"
            ].forEach(pref => {
                try {
                    var type = ServPrefs.getPrefType(pref);
                    if (type != ServPrefs.PREF_INVALID)
                        ServPrefs.removeObserver(pref, this, false);
                } catch(e) {}
            });
            try {
                ServPrefs.removeObserver("extensions.add_toolbar_buttons.obs.", this, false);
            } catch(e) {}
            [
                "b-image-toggle", "b-stop-animation", "b-autoplay", "b-javascript", "b-cookie-toggle", "b-zoom-toggle", "toolbaritem-b-toggle-proxy", "toolbaritem-b-undo-tab", "b-close-other-tabs", "b-close-all-tabs", "b-restart-app",
                "b-about-config", "b-about-downloads", "b-about-about", "b-clear-data", "b-preferences", "b-bookmark-nopop", "b-snap-back", "b-top-page", "b-bottom-page", "b-up-page", "b-down-page", "b-find-bar", "b-clear-bar", "b-newtab",
                "b-paste-and-go", "b-copy-and-go", "b-profilefolder", "b-pass-words", "b-toggle-styles", "b-open-console", "b-text-to-link", "b-addons-manager", "b-open-file", "b-saveas", "b-close-toolbars", "b-reduce", "b-enlarge", "b-loads-favicons"
            ].forEach(ids => {
                try {
                    CustomizableUI.destroyWidget(ids);
                } catch(e) {}
            });
            this.initialized = false;
        }
        for (let win of contExt.windowManager.getAll())
            this.removeButtonStyle(win.window);
    }
};

this.addToolbarButtons = class extends ExtensionAPI {
    onShutdown(reason) {
        if (reason != "APP_SHUTDOWN")
            add_toolbar_buttons.uninit();
    }
    getAPI(context) {
        contExt = context.extension;
        baseUri = contExt.baseURI.spec;
        return {
            addToolbarButtons: {
                initExt() {
                    add_toolbar_buttons.init();
                },
                loadWin(winInfo) {
                    add_toolbar_buttons.loadButtonStyle(contExt.windowManager.get(winInfo).window);
                },
                getPref(arr) {
                    return arr.map(name => [name, add_toolbar_buttons.GetPref(name)]);
                },
                setPref(arr) {
                    arr.forEach(nv => {
                        add_toolbar_buttons.SetPref(nv[0], nv[1]);
                    });
                }
            }
        };
    }
};
